
if (systemType == "PC"){
  cvDir <- "C:/Documents and Settings/gillette/My Documents/My Dropbox/cvGUI/"
  clusterDir <- "C:/Documents and Settings/gillette/My Documents/research/ClusterAnalysis/"
  baseCodeDir <- "G:/Dropbox/RCode/"
  motifAnalysisDir <- "C:/Documents and Settings/gillette/My Documents/My Dropbox/Motif Analysis/Motif Analysis R Files/"
  homeDir <- "C:/"
  motifCodeDir <- 'G:/Dropbox/Motif Analysis/Motif Analysis R Files/'
  motifDataDirectory <- "C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/"
} else if (systemType =="Mac"){
  #cvDir <- "/Users/toddgillette/Dropbox/cvGUI/"
  #cvDataDir <- "/Users/toddgillette/Dropbox/cvGUI/"
  motifDataDirectory <- "/Users/toddgillette/Dropbox/Motif Analysis/Data/"
}else{  
  cvDir <- "/home/tgillett/ClusterAnalysis/"
  cvDataDir <- "/home/tgillett/results/"
  clusterDir <- "/home/tgillett/ClusterAnalysis/"
  baseCodeDir <- "/home/tgillett/RUtils/"
  homeDir <- "/home/tgillett/"
  motifCodeDir <- '/home/tgillett/ClusterAnalysis/'
  motifDataDirectory <- "/home/tgillett/results/"
}
utilDir <- baseCodeDir
figDir <- paste(homeDir,"/figures/Pasta1/",sep="")

#setwd('C:/Documents and Settings/gillette/My Documents/My Dropbox/Motif Analysis/Motif Analysis R Files/')

library(ggplot2)

source(paste(utilDir,'Utils.r',sep=''))
source(paste(utilDir,'VisualizationUtils.r',sep=''))
source(paste(motifCodeDir,'PRAnalysisFunctions.r',sep=''))
source(paste(motifCodeDir,'RawKmerFreqsFunctions.r',sep=''))

#source('TimeEstimating/TimePredictionFunctions.r')

prDataDirectory <- paste(motifDataDirectory,"/PercentileRanks/",sep="")

#metaData <- read.csv(paste(motifDataDirectory,"arborMetaData-NM-MapType2.csv",sep=""))
#rownames(metaData)<-metaData$Sequence

# Load sequence length data using ClassComparisonDefs.r
masterMetaData <- read.csv(paste(homeDir,"arborMetaData-NM-MapType2.csv",sep=""),na.strings="",stringsAsFactors=FALSE,row.names=1)
if ("CellType"%in%colnames(masterMetaData)){
  colnames(masterMetaData)[colnames(masterMetaData)=="CellType"] <- "Class2"
}
source(paste(clusterDir,"ClassComparisonDefs.r",sep=""))

motifMetaData <- usedMetaData
motifMetaData[motifMetaData$ArborType=="BasalDendrite","ArborType"] <- "Dendrite"
SeqLenData <- read.csv(paste(homeDir,"SequenceLengths-NM-MapType2.csv",sep=""),row.names=1)
SeqLenData2D <- read.csv(paste(homeDir,"SequenceLengths-NM_SpurLen2D-MapType2.csv",sep=""),row.names=1)
#sharedSeqs <- intersect(rownames(SeqLenData2D),rownames(SeqLenData))
#sharedSeqs <- intersect(rownames(motifMetaData),sharedSeqs)
sharedSeqs <- intersect(rownames(motifMetaData),rownames(SeqLenData2D))
sharedDends <- intersect(sharedSeqs,rownames(subset(usedMetaData,ArborType=="Dendrite"&Protocol!="Culture"&ExperCond=="Control")))

originalDends <- intersect(rownames(SeqLenData),rownames(subset(masterMetaData,ArborType%in%c("Dendrite","BasalDendrite")&Protocol!="Culture"&ExperCond=="Control")))
originalDends[!originalDends%in%sharedDends]
sum(!originalDends%in%sharedDends)

SeqLenData <- SeqLenData[sharedSeqs,,drop=F]
SeqLenData2D <- SeqLenData2D[sharedSeqs,,drop=F]
motifMetaData[sharedSeqs,"SeqLen"] <- SeqLenData2D[sharedSeqs,"SeqLen"]
lengthChange <- SeqLenData[,"SeqLen"]-SeqLenData2D[,"SeqLen"]
names(lengthChange) <- sharedSeqs
lengthChange <- lengthChange[sharedDends]

relLengthChange <- lengthChange/SeqLenData[names(lengthChange),"SeqLen"]
lengthChangeDF <- data.frame(Change=lengthChange,PercentChange=relLengthChange,Initial=SeqLenData[sharedDends,"SeqLen"],Final=SeqLenData2D[sharedDends,"SeqLen"])
rownames(lengthChangeDF) <- sharedDends
                             
png("Dendrite-2umSpurRemovalLengthChangeHistogram.png")
hist(lengthChange[lengthChange>0&lengthChange<200],breaks=50)
dev.off()

png("Dendrite-2umSpurRemovalRelativeLengthChangeHistogram.png")
hist(relLengthChange[relLengthChange>0],breaks=40)
dev.off()

with(lengthChangeDF,sum(Change>0))
with(lengthChangeDF,mean(Change>0))

with(lengthChangeDF,sum(Change>0&Initial<50))
with(lengthChangeDF,mean(Change>0&Initial<50))
with(lengthChangeDF,sum(Change>0&Final<50))
with(lengthChangeDF,mean(Change>0&Final<50))


diffLim <- -1
#cbind(motifMetaData[names(lengthChange)[lengthChange > diffLim],c("Archive","Class2"),drop=F],lengthChange[lengthChange > diffLim])
lenChangeMeta <- cbind(motifMetaData[names(lengthChange)[lengthChange > diffLim],"Class2",drop=F],Diff=lengthChange[lengthChange > diffLim])
lenChangeSummary <- aggregate(lenChangeMeta[,2],by=list(lenChangeMeta$Class2),function(x){mean(x>0)})
lenChangeSummary[lenChangeSummary$x > 0,]

diffLim <- 5
kawaguchiDendrites <- rownames(subset(masterMetaData,Archive=="Kawaguchi"&ArborType=="Dendrite"))
kawaguchiLengthChange <- cbind(motifMetaData[kawaguchiDendrites,"Class2",drop=F],Diff=lengthChange[kawaguchiDendrites])
aggregate(kawaguchiLengthChange[,2],by=list(kawaguchiLengthChange$Class2),mean)

lengthChange[rownames(subset(motifMetaData,Archive=="Kawaguchi"&ArborType=="Dendrite"))]

# Setup variables

k <- 2
kPlus <- k+1
dataset <- "NM_SpurLen5"
defaultOrder <- "STL"
defaultMethod <- 8
defaultThreshold <- "0.0"
defaultThreshType <- "Whole"

# Set up palettes
# The palette with grey:
cbPalette <- c("#999999", "#E69F00", "#56B4E9", "#009E73", "#F0E442", "#0072B2", "#D55E00", "#CC79A7")
# The palette with black:
cbbPalette <- c("#000000", "#E69F00", "#56B4E9", "#009E73", "#F0E442", "#0072B2", "#D55E00", "#CC79A7")
# old arbor pallette (red, light cyan, greenish blue)
myArborPal <- c("#E52400", "#56D4E9","#0072B2", "#999999", "#555555", "#111111", "#CCAA33", "#C0BB38")

origWithApicalPal <- c("#22CCCC","#2222CC","#CC22CC", "#999999", "#555555", "#444477", "#AA88AA", "#BA99AA")
# New arbor palette (Apical=green, Axon=magenta, Dendrite=blue)
withApicalPal <- c("#22CC22","#CC22CC","#2222CC", "#999999", "#555555", "#444477", "#AA88AA", "#BA99AA")

# New arbor palette (Axon=magenta, Dendrite=blue)
#origNoApicalPal <- c("#22CCCC","#2222CC", "#999999", "#333333", "#666666", "#AA88AA", "#BA99AA")
origNoApicalPal <- c("#22CCCC","#2222CC", "#666666", "#999999", "#333333")
modNoApicalPal <- c("#CC22CC","#2222CC", "#999999", "#333333", "#666666", "#AA88AA", "#BA99AA")
noApicalPal <- modNoApicalPal
# New arbor palette (Axon=magenta, AdultDendrite=blue, YoungDendrite=Cyan)
dendAgePal <- c("#CC22CC","#2222CC","#22CCCC", "#999999", "#555555", "#444477", "#AA88AA", "#BA99AA")

###### Reading in data ######

surrogateSetNum <- 1
numSets <- 100
prDataB8STL <- list()
prDataB8LTS <- list()
prDataB8Combo <- list()
for (k in 1:3){
  prFilename <- getPRFilename(k,dataset=dataset,sets=numSets,surrogateSet=surrogateSetNum,order="STL",baselineMethod=8,threshold="0.0",thresholdTypeString="Whole",directory=prDataDirectory,sourceTraversal="STL")
  prDataB8STL[[k]] <- read.csv(prFilename,stringsAsFactors=F,row.names=1)
  prDataB8STL[[k]] <- prDataB8STL[[k]][,colnames(prDataB8STL[[k]])!="N",drop=F]
  
  prDataB8Combo[[k]] <- prDataB8STL[[k]]
  
  if (k >= 3){
    # Read in LTS k-mers
    prDataB8LTS[[k]] <- read.csv(getPRFilename(k,dataset=dataset,sets=numSets,surrogateSet=surrogateSetNum,order="LTS",baselineMethod=8,threshold="0.0",thresholdTypeString="Whole",directory=prDataDirectory,sourceTraversal="STL"),stringsAsFactors=F,row.names=1)
    prDataB8LTS[[k]] <- prDataB8LTS[[k]][,colnames(prDataB8LTS[[k]])!="N",drop=F]
    tmp <- prDataB8LTS[[k]]
    # For merging, get rid of LTS k-mers that have an STL counterpart
    inds <- grep("[ACT]C+[ACT]",colnames(tmp),perl=T)
    colnames(tmp) <- paste("L-",colnames(tmp),sep="")
    prDataB8Combo[[k]] <- cbind(prDataB8STL[[k]],tmp[,-inds])
    colnames(prDataB8Combo[[k]]) <- c(colnames(prDataB8STL[[k]]),colnames(tmp)[-inds])
  }
  
  # Remove anything from Protocol:Culture or !ExperCond:Control
  # Already removed now that we're using ClassComparisonDefs.r
  #prDataB8Combo[[k]] <- prDataB8Combo[[k]][rownames(subset(motifMetaData[rownames(prDataB8Combo[[k]]),],Protocol!="Culture"&ExperCond=="Control")),]
}
if (exists("tmp")) rm(tmp)

prSurrogateDataB8STL <- list()
prSurrogateDataB8LTS <- list()
prSurrogateDataB8Combo <- list()
for (k in 1:5){
  prSurrogateDataB8STL[[k]] <- read.csv(getPRFilename(k,sets=40,surrogateSet=surrogateSetNum,order="STL",baselineMethod=8,threshold="0.0",thresholdTypeString="Whole",directory=prDataDirectory,sourceTraversal="STL",useRandomSet=1,useRandomK="Plus1"),stringsAsFactors=F,row.names=1)
  prSurrogateDataB8STL[[k]] <- prSurrogateDataB8STL[[k]][,colnames(prSurrogateDataB8STL[[k]])!="N",drop=F]

  prSurrogateDataB8Combo[[k]] <- prSurrogateDataB8STL[[k]]
  
  if (k >= 3){
    # Read in LTS k-mers
    prSurrogateDataB8LTS[[k]] <- read.csv(getPRFilename(k,sets=40,surrogateSet=surrogateSetNum,order="LTS",baselineMethod=8,threshold="0.0",thresholdTypeString="Whole",directory=prDataDirectory,sourceTraversal="STL",useRandomSet=1,useRandomK="Plus1"),stringsAsFactors=F,row.names=1)
    prSurrogateDataB8LTS[[k]] <- prSurrogateDataB8LTS[[k]][,colnames(prSurrogateDataB8LTS[[k]])!="N",drop=F]
    tmp <- prSurrogateDataB8LTS[[k]]
    # For merging, get rid of LTS k-mers that have an STL counterpart
    inds <- grep("[ACT]C+[ACT]",colnames(tmp),perl=T)
    colnames(tmp) <- paste("L-",colnames(tmp),sep="")
    prSurrogateDataB8Combo[[k]] <- cbind(prSurrogateDataB8STL[[k]],tmp[,-inds])
    colnames(prSurrogateDataB8Combo[[k]]) <- c(colnames(prSurrogateDataB8STL[[k]]),colnames(tmp)[-inds])
  }
}
rm(tmp)

# Raw %C data
realCFreqs <- getKmerFreqs(1,dataset=dataset,travOrder="STL")
# Remove anything from Protocol:Culture or !ExperCond:Control
realCFreqs <- realCFreqs[rownames(subset(motifMetaData[rownames(realCFreqs),],Protocol!="Culture"&ExperCond=="Control")),,drop=F]

# Terminal growth
termGrowCFreqs <- getKmerFreqs(1,travOrder="LTS",useRandomSet=9,useRandomK=0,method=2,sourceTraversal="")
termGrowCFreqs <- cbind(termGrowCFreqs,SeqLen=masterMetaData[rownames(termGrowCFreqs),"SeqLen"])

# Terminal & segmental growth
segmentGrowCFreqs <- getKmerFreqs(1,travOrder="LTS",useRandomSet=1,useRandomK=0,method=9,sourceTraversal="")
segmentGrowCFreqs <- cbind(segmentGrowCFreqs,SeqLen=masterMetaData[rownames(segmentGrowCFreqs),"SeqLen"])
#interstGrowCFreqs <- getKmerFreqs(1,useRandomSet=1,useRandomK=0,method=9)

# Uniform distribution of tree shapes
treeShapeCFreqs <- getKmerFreqs(1,travOrder="LTS",useRandomSet=21,useRandomK=0,method=8,sourceTraversal="")
treeShapeCFreqs <- cbind(treeShapeCFreqs,SeqLen=masterMetaData[rownames(treeShapeCFreqs),"SeqLen"])

# Plot %C for different arbor types
axonCFreq <- getSubset2(realCFreqs,list(ArborType="Axon",ExperCond="Control",Protocol=c("In vivo","In vitro","Not reported")))
axonCFreq <- cbind(axonCFreq,SeqLen=motifMetaData[rownames(axonCFreq),"SeqLen"])
dendriteCFreq <- getSubset2(realCFreqs,list(ArborType=c("Dendrite","BasalDendrite"),ExperCond="Control",Protocol=c("In vivo","In vitro","Not reported")))
dendriteCFreq <- cbind(dendriteCFreq,SeqLen=motifMetaData[rownames(dendriteCFreq),"SeqLen"])
apicalCFreq <- getSubset2(realCFreqs,list(ArborType="ApicalDendrite",ExperCond="Control",Class2="Pyramidal cell",Protocol=c("In vivo","In vitro","Not reported")))
apicalCFreq <- cbind(apicalCFreq,SeqLen=motifMetaData[rownames(apicalCFreq),"SeqLen"])

pyrAxonCFreq <- getSubset2(axonCFreq,list(ArborType="Axon",ExperCond="Control",Class2="Pyramidal cell",Protocol=c("In vivo","In vitro","Not reported")))
pyrDendriteCFreq <- getSubset2(dendriteCFreq,list(ArborType=c("Dendrite","BasalDendrite"),ExperCond="Control",Class2="Pyramidal cell",Protocol=c("In vivo","In vitro","Not reported")))

# Read in growth model alternative dataset
if (systemType == "KrasClust"){
  growthDir <- "/home/tgillett/results/MotifAnalysis/"
}else{
  growthDir <- "C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/GrowthModelResults/"
}
growthData <- read.csv(paste(growthDir,"GrowthProperties.csv",sep=""),stringsAsFactors=F)
growthData <- rbind(growthData,read.csv(paste(growthDir,"ApicalModelGrowthProperties.csv",sep="")))
growthData <- rbind(growthData,read.csv(paste(growthDir,"ApicalModelV2GrowthProperties.csv",sep="")))

coreGrowthData <- read.csv(paste(growthDir,"GrowthPropertiesExt.csv",sep=""),stringsAsFactors=F)
growthDataExt <- subset(coreGrowthData,Growth!="AxonModel")
growthDataExt <- rbind(growthDataExt,read.csv(paste(growthDir,"AxonModelGrowthProperties.csv",sep=""))

otherGrowthData <- read.csv(paste(growthDir,"AllModelGrowthProperties.csv",sep=""),stringsAsFactors=F)

coreGrowthData <- subset(coreGrowthData,Growth%in%c("Terminal","Segmental"))

## End data read


############ Analysis Setup ###########

## Core analysis: All neurites, and neurites by arbor type (axon, dendrite, apical dendrite)
allNeuritesSpec <- list(ExperCond="Control")
axonsSpec <- list(ExperCond="Control",ArborType="Axon")
dendritesSpec <- list(ExperCond="Control",ArborType=c("Dendrite","BasalDendrite"))
apicalsSpec <- list(ExperCond="Control",ArborType="ApicalDendrite")

pyrAxonsSpec <- list(ExperCond="Control",ArborType="Axon",Class2="Pyramidal cell")
pyrDendritesSpec <- list(ExperCond="Control",ArborType=c("Dendrite","BasalDendrite"),Class2="Pyramidal cell")
pyrApicalsSpec <- list(ExperCond="Control",ArborType="ApicalDendrite",Class2="Pyramidal cell")

specifications <- list(allNeuritesSpec,axonsSpec,apicalsSpec,dendritesSpec)
names(specifications) <- c("All Neurites","Axons","ApicalDendrites","Dendrites")

pyrSpecs <- list(pyrAxonsSpec,pyrApicalsSpec,pyrDendritesSpec)
names(pyrSpecs) <- c("Axons","ApicalDendrites","Dendrites")

allNeuriteNames <- rownames(getSubset2(motifMetaData,allNeuritesSpec,motifMetaData,minLength=minSize))
axonNames <- rownames(getSubset2(motifMetaData,axonsSpec,motifMetaData))
dendriteNames <- rownames(getSubset2(motifMetaData,dendritesSpec,motifMetaData))
apicalNames <- rownames(getSubset2(motifMetaData,apicalsSpec,motifMetaData))

pyrAxonNames <- rownames(getSubset2(motifMetaData,pyrAxonsSpec,motifMetaData))
pyrDendriteNames <- rownames(getSubset2(motifMetaData,pyrDendritesSpec,motifMetaData))
pyrApicalNames <- rownames(getSubset2(motifMetaData,pyrApicalsSpec,motifMetaData))

culturedNeurons <- rownames(getSubset2(motifMetaData,list(Protocol="Culture"),motifMetaData))
  
#### % Captured ####
#offsets <- c(0.6,0.5,0.65,0.75)
offsets <- c(0.5,0.5,0.5,0.5)

currOrder <- "STL"
kRange <- 1:5
myResults <- matrix(0,nrow=2*length(specifications),ncol=length(kRange))
colnames(myResults) <- kRange
rownames(myResults) <- 1:nrow(myResults)
diffSEs <- matrix(0,nrow=length(specifications),ncol=length(kRange))
colnames(diffSEs) <- kRange
rownames(diffSEs) <- 1:nrow(diffSEs)
resultOffset <- 0 # 8
minSize <- 18
maxSize <- NaN
removeATTFlag <- TRUE
ltsOnly <- FALSE
useAlternate <- F

# Set data source
myData <- prDataB8Combo
mySurrogateData <- prSurrogateDataB8Combo
resultTitle <- "With LTS"

myData <- prDataB8STL
mySurrogateData <- prSurrogateDataB8STL
resultTitle <- ""

for (k in kRange){
  sharedSeqs <- intersect(rownames(myData[[k]]),rownames(mySurrogateData[[k]]))
  myData[[k]] <- myData[[k]][sharedSeqs,,drop=F]
  mySurrogateData[[k]] <- mySurrogateData[[k]][sharedSeqs,,drop=F]
}

#myData <- prDataB8LTS_40
#mySurrogateData <- prSurrogateDataB8LTS_40
#percentCaptured <- matrix("",2+ncol(myData),1+2*length(specifications))

## New faster and simpler version (I hope) - CURRENTLY NOT WORKING
capturedDataNeuriteNames <- intersect(allNeuriteNames,rownames(myData[[1]]))
subData <- myData[[1]][capturedDataNeuriteNames,]
percentCaptured <- data.frame(subData)
for (k in 2:length(myData)){
  percentCaptured <- cbind(percentCaptured,apply(myData[[k]][capturedDataNeuriteNames,],1,mean))
}
colnames(percentCaptured) <- 1:ncol(percentCaptured)
rownames(percentCaptured) <- capturedDataNeuriteNames
percentCapturedLong <- reshape(percentCaptured,direction="long",varying=list(colnames(percentCaptured)),times=colnames(percentCaptured),idvar="SeqName",ids=rownames(percentCaptured),timevar="k",v.names="PercentCaptured")

percentCapturedByK <- ggplot(percentCapturedLong,aes(k,PercentCaptured))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  labs(x="K", y="% Captured")
ggsave(paste(figDir,"PercentCapturedByK-All.png"),percentCapturedByK)
         
## Functioning version - Generate plot with each arbor type in its own panel
#CairoWin()
#par(mfrow=c(2,2))
#par(mar=c(2,2,2,1), oma=c(1,1.5,1,1))
for (i in 1:length(specifications)){
  specification <- specifications[[i]]
  realMeans <- kRange
  names(realMeans) <- kRange
  surrogateMeans <- kRange
  realSDs <- kRange
  surrogateSDs <- kRange
  diffSE <- kRange
  # Get the spec name
  if (is.null(names(specifications))){
    specName <- getSetString(specification)
  }else{
    specName <- names(specifications)[i]
  }
  for (k in kRange){
    # Get the data subset
    subData <- getSubset2(myData[[k]],specification,motifMetaData,minLength=minSize,maxLength=maxSize)
    subSurrogateData <- getSubset2(mySurrogateData[[k]],specification,motifMetaData,minLength=minSize,maxLength=maxSize)
    
    # Remove ATT-related kmers
    if (removeATTFlag && k >= 3){
      subData <- subData[,removeATT(currOrder,colnames(subData)),drop=F]
      subSurrogateData <- subSurrogateData[,removeATT(currOrder,colnames(subSurrogateData)),drop=F]
    }
    # Determine which columns to run
    if (ltsOnly){
      inds <- grep("L-",colnames(subData))
      subData <- subData[,inds,drop=F]
      subSurrogateData <- subSurrogateData[,inds,drop=F]
    }
    
    #outlierData <- calculatePROutlierRatio(subData,k=k,alpha=0.05)
    #surrogateOutlierData <- calculatePROutlierRatio(subSurrogateData,k=k,alpha=0.05)
    captured <- apply(subData,1,function(x){mean(x > .025 & x < .975)})
    capturedSurrogate <- apply(subSurrogateData,1,function(x){mean(x >= .025 & x <= .975)})
    
    kInd <- k-min(kRange)+1
    realMeans[kInd] <- mean(captured)
    realSDs[kInd] <- sd(captured)
    
    surrogateMeans[kInd] <- mean(capturedSurrogate)
    surrogateSDs[kInd] <- sd(capturedSurrogate)
    diffSE[kInd] = sqrt((var(captured)+var(capturedSurrogate)+cov(captured,capturedSurrogate))/length(captured))
  }
  
  myResults[resultOffset + 2*i-1,] <- realMeans
  rownames(myResults)[resultOffset + 2*i-1] <- paste(resultTitle,specName,"Real")

  myResults[resultOffset + 2*i,] <- surrogateMeans-realMeans
  rownames(myResults)[resultOffset + 2*i] <- paste(resultTitle,specName,"Diff")
  
  diffSEs[resultOffset+i,] <- diffSE
  rownames(diffSEs)[resultOffset+i] <- paste(resultTitle,specName,"Diff SEs")
  
  realSEs <- realSDs/sqrt(nrow(subData))
  surrogateSEs <- surrogateSDs/sqrt(nrow(subData))
  
  # Bar plot of results
#  if (is.nan(maxSize)){
#    title <- paste(specName," (Min #bifs: ",minSize,")",sep="")
#  }else{
#    title <- paste(specName," (Min: ",minSize,"; Max: ",maxSize,")",sep="")
#  }
#   title <- specName
#   if (useAlternate){
#     realFlip <- 1-realMeans
#     surrFlip <- 1-surrogateMeans
#     vals <- realFlip/surrFlip
#     barplot(vals,main=title,xlab="k",ylab="Real-Baseline captured ratio")
#     realSE <- realSDs/sqrt(nrow(subData))
#     surrSE <- surrogateSDs/sqrt(nrow(subData))
#     errs <- sqrt((surrSE*realFlip/surrFlip^2)^2 + (realSE/surrFlip)^2)
#     #errs <- sqrt(realSDs^2/nrow(subData) + surrogateSDs^2/nrow(subData))
#     error.bar(1.2*(kRange-min(kRange))+.7,vals,errs)
#   }else{
#     #offset <- floor(20*min(realMeans)-.5)/20
#     offset <- offsets[i]
#     png(paste("/home/tgillett/results/PercentCaptured_",gsub(" ","",specName),"_SurrogateN100_Min",offset,".png",sep=""),width=800,height=800)
#     barplot(realMeans-offset,ylim=c(offset,1),offset=offset,main=title,xlab="k",ylab="Average proportion of k-mers captured by Baseline")
#     error.bar(1.2*(kRange-min(kRange))+.7,realMeans,realSDs/sqrt(nrow(subData)))
#     barplot(1-surrogateMeans,offset=surrogateMeans,col="gray50",add=T)
#     error.bar(1.2*(kRange-min(kRange))+.7,surrogateMeans,surrogateSDs/sqrt(nrow(subData)))
#     dev.off()
#   }
}


#### Explore dip in %captured from Dendrite monomers to dimers ####
specification <- specifications[[4]]
tmp <- getSubset2(myData[[1]],specification,motifMetaData,minLength=minSize,maxLength=maxSize)
subData <- cbind(tmp,getSubset2(myData[[2]],specification,motifMetaData,minLength=minSize,maxLength=maxSize))

ggplot(subData,aes(x=C,y=AC))+geom_density2d()

ggplot(subData,aes(x=C,y=AC))+
  stat_density2d(aes(alpha=..level..), geom="polygon") +
  scale_fill_gradient(low="blue", high="green")

captured1 <- apply(subData[,1,drop=F],1,function(x){mean(x > .025 & x < .975)})
captured2 <- apply(subData[,-1],1,function(x){mean(x > .025 & x < .975)})
#capturedSurrogate <- apply(subSurrogateData,1,function(x){mean(x >= .025 & x <= .975)})

newDF <- data.frame(C=captured1,Dimer=captured2)
newDF <- data.frame(C=captured1+rnorm(nrow(subData),0,.05),Dimer=captured2+rnorm(nrow(subData),0,.05))

ggplot(newDF,aes(x=C,y=Dimer))+geom_density2d()

dimerCapturedProb <- mean(subset(newDF,C==1)$Dimer)
plot(density(subset(newDF,C==0)$Dimer))

CairoWin()
randomCase <- rbinom(sum(newDF$C==1),9,dimerCapturedProb)/9
hist(subset(newDF,C==1)$Dimer)
plot(density(subset(newDF,C==1)$Dimer))
lines(density(rbinom(sum(newDF$C==1),9,dimerCapturedProb)/9),col=2)

ggdf <- data.frame(Captured=c(randomCase,subset(newDF,C==1)$Dimer),Group=c(rep("Random",length(randomCase)),rep("Real",length(randomCase))))
ggplot(ggdf, aes(Captured, fill = Group)) + geom_histogram(alpha = 0.5, aes(y = ..density..), position = 'identity')

#### %C compared to growth models ####

#CairoWin()

#pcVsSeqLenLevels <- c("Apical","Axon","Dendrite","Segmental Growth","Tree Shapes","Terminal Growth","Apical Model")
pcVsSeqLenLevels <- c("Apical","Axon","Dendrite","Terminal Growth","Segmental Growth","Tree Shapes")

#plotdf <- rbind(rbind(axonCFreq,apicalCFreq),dendriteCFreq)
#arborGroup <- c(rep("Axon",nrow(axonCFreq)),rep("Apical",nrow(apicalCFreq)),rep("Dendrite",nrow(dendriteCFreq)))
#plotdf <- rbind(rbind(axonCFreq,apicalCFreq[apicalCFreq$SeqLen < 70,]),dendriteCFreq)
#arborGroup <- c(rep("Axon",nrow(axonCFreq)),rep("Apical",sum(apicalCFreq$SeqLen < 70)),rep("Dendrite",nrow(dendriteCFreq)))
# No apical dendrites
plotdf <- rbind(axonCFreq,dendriteCFreq)
arborGroup <- c(rep("Axon",nrow(axonCFreq)),rep("Dendrite",nrow(dendriteCFreq)))
# Pyramidal cell neurites
plotdf <- rbind(rbind(pyrAxonCFreq[pyrAxonCFreq$SeqLen < 180,],apicalCFreq[apicalCFreq$SeqLen < 70,]),pyrDendriteCFreq[pyrDendriteCFreq$SeqLen < 56,])
arborGroup <- c(rep("Axon",sum(pyrAxonCFreq$SeqLen < 180)),rep("Apical",sum(apicalCFreq$SeqLen < 70)),rep("Dendrite",sum(pyrDendriteCFreq$SeqLen < 56)))

plotdf$Group <- factor(arborGroup,levels=pcVsSeqLenLevels,ordered=T)

plotdf2 <- rbind(rbind(termGrowCFreqs,segmentGrowCFreqs), treeShapeCFreqs)
plotdf2$Group <- c(rep("Terminal Growth",nrow(termGrowCFreqs)),rep("Segmental Growth",nrow(segmentGrowCFreqs)),rep("Tree Shapes",nrow(treeShapeCFreqs)))
plotdf2$Group <- factor(plotdf2$Group,levels=pcVsSeqLenLevels,ordered=T)

# Alternative growth models to use
plotdf2 <- extremeQSGrowthKmers[,c("PercentC","Length","Growth")]
colnames(plotdf2) <- c("C","SeqLen","Group")
plotdf2$Group <- as.character(plotdf2$Group)
plotdf2[plotdf2$Group == "Q0S0.4","Group"] <- "Low-order Biased Terminal Growth"
plotdf2[plotdf2$Group == "Q0.7S0","Group"] <- "Interstitially-Biased Growth"
tmp <- treeShapeCFreqs
tmp$Group <- "Tree Shapes"
plotdf2 <- rbind(plotdf2,tmp)
pcVsSeqLenLevels <- c("Apical","Axon","Dendrite","Interstitially-Biased Growth","Tree Shapes","Low-order Biased Terminal Growth")
plotdf2$Group <- factor(plotdf2$Group,levels=pcVsSeqLenLevels,ordered=T)

# Mix biased terminal growth with pure segmental growth
plotdf2 <- extremeQSGrowthKmers[extremeQSGrowthKmers$Growth=="Q0S0.4",c("PercentC","Length","Growth")]
colnames(plotdf2) <- c("C","SeqLen","Group")
plotdf2$Group <- as.character(plotdf2$Group)
plotdf2 <- rbind(plotdf2,cbind(segmentGrowCFreqs,Group=rep("Segmental Growth",nrow(termGrowCFreqs))))
plotdf2[plotdf2$Group == "Q0S0.4","Group"] <- "Low-order Biased Terminal Growth"
tmp <- treeShapeCFreqs
tmp$Group <- "Tree Shapes"
plotdf2 <- rbind(plotdf2,tmp)
#pcVsSeqLenLevels <- c("Axon","Dendrite","Segmental Growth","Tree Shapes","Low-order Biased Terminal Growth")
pcVsSeqLenLevels <- c("Axon","Dendrite","Low-order Biased Terminal Growth","Segmental Growth","Tree Shapes")
plotdf2$Group <- factor(plotdf2$Group,levels=pcVsSeqLenLevels,ordered=T)
plotdf$Group <- factor(as.character(plotdf$Group),levels=pcVsSeqLenLevels,ordered=T)

# Add in apical models
growthSub <- growthData[growthData$Growth%in%c("ApicalModelV2"),c("PercentC","Length","Growth")]
growthSub$Growth <- "Apical Model"
growthSub <- subset(growthSub,Length <= 60)
growthSub$Length <- growthSub$Length + round(rnorm(nrow(growthSub),0,2))
colnames(growthSub) <- colnames(plotdf)
plotdf2 <- rbind(plotdf2,growthSub)

#plotdfCombo <- rbind(plotdf, plotdf2)
#plotdfCombo <- rbind(plotdf[,-4],plotdf2) # When AgeClass is in plotdf (see farther below)

#ggplot(plotdfCombo,aes(Group,C,fill=Group))+
gg_pc_bar <- ggplot(plotdf,aes(Group,C,fill=Group))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  scale_fill_manual(values=withApicalPal)+
  coord_cartesian(ylim=ylimsByK[[k]])+
  theme(axis.text.x = element_text(angle = 90, hjust = 0))
# Box&whisker plot
ggplot(plotdfCombo,aes(Group,C,fill=Group))+
  geom_boxplot(notch=T)+
  scale_fill_manual(values=withApicalPal)+
  theme(axis.text.x = element_text(angle = 90, hjust = 0))

#### %C by Sequence Length ####

# Plot C frequency smooths: by arbor type and with randoms
#png("results/PercentCBySeqLen-AxDe-ExtremeQS.png")
#png("results/PercentCBySeqLen-AxDe.png",width=800,height=600)
gg_cByLen <- ggplot(subset(plotdf,SeqLen<250),aes(x = SeqLen, y = C, colour = Group, group=Group)) + 
  stat_smooth(method = "loess", span=.3, se = TRUE,level = 0.95, aes(fill = Group),size=1)+
  stat_smooth(data=plotdf2, method = "loess", span=.3, se = FALSE,size=0.7)+
  #scale_colour_manual(values=myArborPal)+
  #scale_colour_manual(values=c(noApicalPal,myArborPal[-c(1,2,3)]))+
  scale_colour_manual(values=origNoApicalPal,guide=F)+
  #scale_fill_manual(values=myArborPal[1:3])+
  scale_fill_manual(values=origNoApicalPal,guide=F)+
  #coord_cartesian(xlim=c(0,250), ylim = c(.2, .7))+
  coord_cartesian(xlim=c(0,180), ylim = c(.2, .7))+
  labs(colour="Arbor Type",fill="Arbor Type",x="Sequence Length", y="Percent C")+
  getTheme(25)
ggsave(gg_cByLen,file=paste(motifDataDirectory,"PercentCByLen-0.3-042814.pdf",sep=""))

# Split dendrites into Young and Adult
plotdfAC <- plotdf[plotdf$Group=="Axon"|motifMetaData[rownames(plotdf),"AgeClass"]%in%c("Young","Adult"),]
plotdfAC$Group2 <- "Axon"
plotdfAC[plotdfAC$Group=="Dendrite","Group2"] <- paste("Dendrite",motifMetaData[rownames(plotdfAC)[plotdfAC$Group=="Dendrite"],"AgeClass"],sep="-")
plotdf2$Group2 <- plotdf2$Group
#png("results/PercentCBySeqLen-AxDe_AgeClass-ExtremeQS.png")
#png("results/PercentCBySeqLen-AxDe_AgeClass.png")
ggplot(subset(plotdfAC,SeqLen<250),aes(x = SeqLen, y = C, colour = Group2, group=Group2)) + 
  stat_smooth(method = "loess", span=.25, se = TRUE,level = 0.95, aes(fill = Group2),size=1)+
  stat_smooth(data=plotdf2, method = "loess", span=.3, se = FALSE,size=0.7,aes(colour=Group),size=0.7)+
  scale_colour_manual(values=dendAgePal)+
  scale_fill_manual(values=dendAgePal)+
  coord_cartesian(xlim=c(0,180), ylim = c(.2, .7))+
  labs(colour="Arbor Type",fill="Arbor Type",x="Sequence Length", y="Percent C")+
  getTheme()

# Split dendrites into cell types and Young and Adult
plotdfCT <- plotdf[plotdf$Group=="Dendrite"&motifMetaData[rownames(plotdf),"AgeClass"]%in%c("Young","Adult","Not reported"),]
youngPyramidal <- intersect(rownames(subset(motifMetaData,AgeClass=="Young"&Class2=="Pyramidal cell")),rownames(plotdfCT))
plotdfCT[youngPyramidal,"Group2"] <- "Pyramidal-Young"
adultPyramidal <- intersect(rownames(subset(motifMetaData,AgeClass=="Adult"&Class2=="Pyramidal cell")),rownames(plotdfCT))
plotdfCT[adultPyramidal,"Group2"] <- "Pyramidal-Adult"
youngInterneuron <- intersect(rownames(subset(motifMetaData,AgeClass=="Young"&Class1=="Interneuron")),rownames(plotdfCT))
plotdfCT[youngInterneuron,"Group2"] <- "Interneuron-Young"
principalYoung <- intersect(rownames(subset(motifMetaData,AgeClass=="Young"&Class1=="Principal cell"&Class2!="Pyramidal cell")),rownames(plotdfCT))
plotdfCT[principalYoung,"Group2"] <- "Principal-Young"
adultGanglion <- intersect(rownames(subset(motifMetaData,AgeClass=="Adult"&Class2=="Ganglion cell")),rownames(plotdfCT))
plotdfCT[adultGanglion,"Group2"] <- "Ganglion-Adult"
principalAdult <- intersect(rownames(subset(motifMetaData,AgeClass=="Adult"&Class1=="Principal cell"&Class2!="Pyramidal cell")),rownames(plotdfCT))
plotdfCT[principalAdult,"Group2"] <- "Principal-Adult"
# NR: 75% Pyramidal, 15% Ganglion
pyramidalNR <- intersect(rownames(subset(motifMetaData,AgeClass=="Not reported"&Class2=="Pyramidal cell")),rownames(plotdfCT))
plotdfCT[pyramidalNR,"Group2"] <- "Pyramidal-NR"
ganglionNR <- intersect(rownames(subset(motifMetaData,AgeClass=="Not reported"&Class2=="Ganglion cell")),rownames(plotdfCT))
plotdfCT[ganglionNR,"Group2"] <- "Ganglion-NR"
plotdfCT <- subset(plotdfCT,!is.na(Group2))

#png("results/PercentCBySeqLen-AxDe_AgeClass-ExtremeQS.png")
#png("results/PercentCBySeqLen-AxDe_AgeClass.png")
#png("results/PercentCBySeqLen-Dend_AgeClass_CellClass.png")
ggplot(subset(plotdfCT,SeqLen<250),aes(x = SeqLen, y = C, colour = Group2, group=Group2)) + 
  stat_smooth(method = "loess", span=.32, se = TRUE,level = 0.95, aes(fill = Group2),size=1)+
  coord_cartesian(xlim=c(0,220), ylim = c(.2, .8))+
  labs(colour="Cell Type",fill="Cell Type",x="Sequence Length", y="Percent C")+
  getTheme()

subset(plotdfCT,SeqLen>100&C>.55)

# Check for confounds for adult/young distinction
numYoungDend <- nrow(subset(motifMetaData,AgeClass=="Young"&ArborType=="Dendrite"&ExperCond=="Control"))
numAdultDend <- nrow(subset(motifMetaData,AgeClass=="Adult"&ArborType=="Dendrite"&ExperCond=="Control"))
numNRDend <- nrow(subset(motifMetaData,AgeClass=="Not reported"&ArborType=="Dendrite"&ExperCond=="Control"))
numOtherDend <- nrow(subset(motifMetaData,!AgeClass%in%c("Young","Adult","Not reported")&ArborType=="Dendrite"&ExperCond=="Control"))

# Widspread, but 25% of Young are Yuste vs 0% of Adult. Chalupa (17%) and Lewis (14%) make up plurality of Adult but none of Young
subset(with(subset(motifMetaData,AgeClass=="Young"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Archive),function(x){round(100*length(x)/numYoungDend)})),x>15/numYoungDend)
subset(with(subset(motifMetaData,AgeClass=="Adult"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Archive),function(x){round(100*length(x)/numAdultDend)})),x>15/numAdultDend)

# Possible confound with 37% Ganglion in Adult vs 3% in Young; and 36%
# Young: 43% Pyramidal, 40% Interneuron, 17% Other principal (4% Motoneuron, 3% Ganglion, 2% Medium Spiny)
# Adult: 50% Pyramidal, 24% Ganglion, 21% Other Principal (5% Medium Spiny, 4% Motoneuron, 3% Stellate), 5% Interneuron
# NR:    78% Pyramidal, 15% Ganglion, 5% Interneuron
subset(with(subset(motifMetaData,AgeClass=="Young"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Class1),function(x){round(100*length(x)/numYoungDend)})),x>15/numYoungDend)
subset(with(subset(motifMetaData,AgeClass=="Adult"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Class1),function(x){round(100*length(x)/numAdultDend)})),x>15/numAdultDend)
subset(with(subset(motifMetaData,AgeClass=="Not reported"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Class1),function(x){round(100*length(x)/numNRDend)})),x>15/numNRDend)

subset(with(subset(motifMetaData,Class1=="Principal cell"&AgeClass=="Young"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Class2),function(x){round(100*length(x)/numYoungDend)})),x>15/numYoungDend)
subset(with(subset(motifMetaData,Class1=="Principal cell"&AgeClass=="Adult"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Class2),function(x){round(100*length(x)/numAdultDend)})),x>15/numAdultDend)
subset(with(subset(motifMetaData,Class1=="Principal cell"&AgeClass=="Not reported"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Class2),function(x){round(100*length(x)/numNRDend)})),x>15/numNRDend)

subset(with(subset(motifMetaData,AgeClass=="Young"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Class1,Class2),function(x){round(100*length(x)/numYoungDend)})),x>15/numYoungDend)
subset(with(subset(motifMetaData,AgeClass=="Adult"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Class1,Class2),function(x){round(100*length(x)/numAdultDend)})),x>15/numAdultDend)

# Species: No confound (similar compositions of mostly rat and mouse
subset(with(subset(motifMetaData,AgeClass=="Young"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Species),function(x){round(100*length(x)/numYoungDend)})),x>15/numYoungDend)
subset(with(subset(motifMetaData,AgeClass=="Adult"&ArborType=="Dendrite"&ExperCond=="Control"),aggregate(Archive,list(Species),function(x){round(100*length(x)/numAdultDend)})),x>15/numAdultDend)

# GLM to test whether cell class has impact on %C which explains AgeClass effect
dendACSub <- subset(plotdfAC,Group=="Dendrite")
dendACSub$AgeClass <- motifMetaData[rownames(dendACSub),"AgeClass"]
dendACSub$ClassGroup <- motifMetaData[rownames(dendACSub),"Class1"]
specificInds <- motifMetaData[rownames(dendACSub),"Class2"] %in% c("Pyramidal cell","Ganglion cell")
dendACSub[specificInds,"ClassGroup"] <- motifMetaData[rownames(dendACSub)[specificInds],"Class2"]
dendACSub <- subset(dendACSub,SeqLen < 250 & ClassGroup != "Not reported")

ggplot(dendACSub,aes(x = SeqLen, y = C, colour = ClassGroup, group=ClassGroup)) + 
  stat_smooth(method = "loess", span=.25, se = TRUE,level = 0.95, aes(fill = Group2),size=1)+
#  stat_smooth(data=plotdf2, method = "loess", span=.3, se = FALSE,size=0.7,aes(colour=Group),size=0.7)+
  coord_cartesian(xlim=c(0,180), ylim = c(.2, .7))+
  labs(colour="Arbor Type",fill="Arbor Type",x="Sequence Length", y="Percent C")

ggplot(subset(dendACSub,ClassGroup=="Pyramidal cell"),aes(x = SeqLen, y = C, colour = AgeClass, group=AgeClass)) + 
  stat_smooth(method = "loess", span=.25, se = TRUE,level = 0.95, aes(fill = Group2),size=1)+
  #  stat_smooth(data=plotdf2, method = "loess", span=.3, se = FALSE,size=0.7,aes(colour=Group),size=0.7)+
  coord_cartesian(xlim=c(0,180), ylim = c(.2, .7))+
  labs(colour="Arbor Type",fill="Arbor Type",x="Sequence Length", y="Percent C")

dendACGLM1 <- glm(C ~ SeqLen + AgeClass + ClassGroup,data=dendACSub)
summary(dendACGLM1)
dendACGLM2 <- glm(C ~ SeqLen * AgeClass * ClassGroup,data=dendACSub)
summary(dendACGLM2)

require(glmnet)
#dendACModelMat <- model.matrix(C~,dendACSub[,c("SeqLen","AgeClass","ClassGroup")])
dendACModelMat <- model.matrix(~SeqLen*AgeClass*ClassGroup,dendACSub[,c("SeqLen","AgeClass","ClassGroup")])
dendACLasso <- glmnet(dendACModelMat,dendACSub$C)

ggplot(plotdf2,aes(x = SeqLen, y = C, colour = Group)) + 
  stat_smooth(method = "loess", span=.5, se = FALSE)+
  scale_colour_manual(values=myArborPal[4:6])+
  coord_cartesian(xlim=c(0,250), ylim = c(.2, .7))+
  labs(colour="Baseline",x="Sequence Length", y="Percent C")

ggplot(plotdf[!rownames(plotdf)%in%rownames(motifMetaData)[motifMetaData$Archive=="Kawaguchi"],],aes(x = SeqLen, y = C, colour = Group)) + 
  stat_smooth(method = "loess", span=.5, se = TRUE,level = 0.95, aes(fill = Group))+
  scale_colour_manual(values=myArborPal)+
  scale_fill_manual(values=myArborPal)+
  coord_cartesian(xlim=c(0,250), ylim = c(.2, .7))+
  labs(colour="Arbor Type",fill="Arbor Type",x="Sequence Length", y="Percent C")

ggplot(plotdf[plotdf$Group=="Apical",],aes(x = SeqLen, y = C, colour = Group)) + 
  geom_point() + 
  stat_smooth(method = "loess", se = TRUE,level = 0.95, aes(fill = Group))+
  coord_cartesian(xlim=c(0,400), ylim = c(.3, .75))+
  labs(colour="Arbor Type",fill="Arbor Type",x="Sequence Length", y="Percent C")
#xlab("Sequence Length")+ ylab("Percent C")+ 

# Percent C by SeqLen without Kawaguchi (dendrites with spurs)
gp1 <- ggplot(plotdf[!rownames(plotdf)%in%rownames(motifMetaData)[subset(motifMetaData,Archive=="Kawaguchi")],],aes(x = SeqLen, y = C, colour = Group)) + 
  stat_smooth(method = "loess", span=.5, se = TRUE,level = 0.95, aes(fill = Group))+
  scale_colour_manual(values=myArborPal)+
  scale_fill_manual(values=myArborPal)+
  coord_cartesian(xlim=c(0,250), ylim = c(.2, .7))+
  labs(colour="Arbor Type",fill="Arbor Type",x="Sequence Length", y="Percent C")

# Group by age class, looking at dendrites only
plotdf$AgeClass <- motifMetaData[rownames(plotdf),"AgeClass"]
CairoWin()
ggplot(subset(plotdf,Group=="Dendrite"&AgeClass%in%c("Not reported","Young","Adult")),aes(x = SeqLen, y = C, group=AgeClass, colour = AgeClass)) + 
  stat_smooth(method = "loess", span=.15, se = TRUE,level = 0.95, size=1, aes(fill=AgeClass))+
  coord_cartesian(xlim=c(0,200), ylim = c(.2, .7))+
  labs(colour="Age Class",fill="Age Class",x="Sequence Length", y="Percent C")+
  getTheme()

#### Add sequence length distributions to %C vs SeqLen plot ####
seqLenDF <- motifMetaData[rownames(dendriteCFreq),c("ArborType","SeqLen"),drop=F]
seqLenDF$ArborType <- "Dendrite"
seqLenDF <- rbind(seqLenDF,motifMetaData[rownames(apicalCFreq),c("ArborType","SeqLen"),drop=F])
seqLenDF <- rbind(seqLenDF,motifMetaData[rownames(axonCFreq),c("ArborType","SeqLen"),drop=F])

#Pyramidal only
seqLenDF <- motifMetaData[rownames(pyrDendriteCFreq),c("ArborType","SeqLen"),drop=F]
seqLenDF$ArborType <- "Dendrite"
seqLenDF <- rbind(seqLenDF,motifMetaData[rownames(apicalCFreq),c("ArborType","SeqLen"),drop=F])
seqLenDF <- rbind(seqLenDF,motifMetaData[rownames(pyrAxonCFreq),c("ArborType","SeqLen"),drop=F])
seqLenDF$ArborType <- factor(seqLenDF$ArborType,levels=c("Dendrite","ApicalDendrite","Axon"),ordered=T)

#png("results/SeqLenDensities-AxDe.png",width=800,height=600)
#ggplot(subset(seqLenDF,SeqLen<=250),aes(SeqLen,fill=ArborType,alpha=.05))+geom_density(linetype=0)+
gg_seqLen <- ggplot(subset(seqLenDF,ArborType!="ApicalDendrite"&SeqLen<=250),aes(SeqLen,fill=ArborType,alpha=.05))+geom_density(linetype=0)+
#  scale_fill_manual(values=withApicalPal[c(3,1,2)])+
  scale_fill_manual(values=origNoApicalPal)+
  scale_y_continuous(breaks=c(0,.05),minor_breaks=0.023)

ggsave(gg_seqLen,file=paste(motifDataDirectory,"SeqLenDistributions_AxDend.pdf",sep=""))

#### Sequence lengths by dendritic type ####
dendSeqLenDF <- motifMetaData[rownames(dendriteCFreq),c("Class1","Class2","SeqLen"),drop=F]
dendSeqLenDF$Group <- dendSeqLenDF$Class1
dendSeqLenDF$Group[dendSeqLenDF$Class1!="Interneuron"] <- dendSeqLenDF$Class2[dendSeqLenDF$Class1!="Interneuron"]
groupCounts <- aggregate(dendSeqLenDF$Group,by=list(dendSeqLenDF$Group),length)
groupsToKeep <- groupCounts[groupCounts$x > 30,1]

groupsToKeep <- groupsToKeep[!groupsToKeep%in%c("Medium spiny cell","Stellate cell")]

CairoWin()
ggplot(subset(dendSeqLenDF,Group%in%groupsToKeep & SeqLen>100 & SeqLen<=300),aes(SeqLen,fill=Group,alpha=.05))+
  #geom_density(linetype=0)+
  geom_histogram(linetype=0)

ggplot(subset(dendSeqLenDF,Group%in%groupsToKeep & SeqLen>100 & SeqLen<=300),aes(SeqLen,colour=Group,alpha=.05))+
  #geom_density(linetype=0)+
  geom_freqpoly(binwidth=30,size=1)

#  scale_fill_manual(values=withApicalPal)+
#  scale_y_continuous(breaks=c(0,.05),minor_breaks=0.023)

# Add %C and plot %C by seq len
dendSeqLenDF <- cbind(dendSeqLenDF,C=dendriteCFreq[rownames(dendSeqLenDF),"C"])
ggplot(subset(dendSeqLenDF,Group%in%groupsToKeep),aes(x = SeqLen, y = C, colour = Group)) + 
  #stat_smooth(method = "loess", span=.5, se = FALSE, size=1)+
  stat_smooth(method = "loess", span=.5, se = TRUE, level=0.95, size=1)+
  coord_cartesian(xlim=c(0,250), ylim = c(.2, .8))+
  labs(colour="Cell Class",x="Sequence Length", y="Percent C")

# Dimer freqs by sequence length for dendrite classes
myData <- prDataB8Combo_40[[2]]
for (dimer in colnames(myData)){
  #for (dimer in c("CC","CT","TA","TC","TT")){
  dimerFreqs <- cbind(dendSeqLenDF,PercentileRank=myData[rownames(dendSeqLenDF),dimer])
  
  #ylims <- sort(plotdf[,1])[nrow(plotdf)*c(.2,.8)]
#  ymin <- min(sapply(c("Axon","Apical","Dendrite"),
#                     function(grp,plotdf){
#                       inds <- as.character(plotdf$Group)==grp
#                       return(sort(plotdf[inds,1])[sum(inds)*.2])},plotdf))
#  ymax <- max(sapply(c("Axon","Apical","Dendrite"),
#                     function(grp,plotdf){
#                       inds <- as.character(plotdf$Group)==grp
#                       return(sort(plotdf[inds,1])[sum(inds)*.8])},plotdf))
#  ylims <- c(ymin,ymax)
  
#  png(paste("C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/Figures/",dataset,"DimersBySeqLen_",dimer,".png",sep=""),300,250)
  CairoWin()
  print(ggplot(subset(dimerFreqs,Group%in%groupsToKeep),aes(x = SeqLen, y = PercentileRank, colour = Group, group=Group)) + 
          stat_smooth(method = "loess", span=.3, se = TRUE,level = 0.95, aes(fill = Group),size=1)+
  #        coord_cartesian(xlim=c(0,250),ylim=ylims)+
          coord_cartesian(xlim=c(0,250))+
          labs(colour="Dendrite Classes",fill="Dendrite Classes",x="Sequence Length", y=paste(dimer,"Percentile Rank")))
#  dev.off()
}

#### %C over various sequence position ranges ####
pcorFilename <- paste(motifDataDirectory,"RawKmerFreqs/CPercentPerRange-NM-RangeType1-SizeSTL.csv",sep='')
pcorFilename <- paste(motifDataDirectory,"RawKmerFreqs/CPercentPerRange-NM-RangeType2-SizeSTL.csv",sep='')

#percentCOverRanges_Abs <- percentCOverRanges_long_mod
#percentCOverRanges_Rel <- percentCOverRanges_long_mod
#percentCOverRanges_long_mod <- percentCOverRanges_Abs
#posRanges <- levels(percentCOverRanges_long_mod$PositionRange)

absolute <- F

# Surrogates
#pcorFilename <- paste(motifDataDirectory,"RawKmerFreqs/CPercentPerRange-NM-B8_Set1_40-SizeSTLSTL.csv",sep='')

pcorFilename <- paste(motifDataDirectory,"RawKmerFreqs/CPercentPerRange-NM_SpurLen2D-RangeType1-SizeSTL.csv",sep='')
percentCOverRanges <- read.csv(pcorFilename,row.names=1)
percentCOverRanges$Group <- masterMetaData[rownames(percentCOverRanges),"ArborType"]
percentCOverRanges$Group[percentCOverRanges$Group=="BasalDendrite"] = "Dendrite"
pcorFilename <- paste(motifDataDirectory,"RawKmerFreqs/CPercentPerRange-TerminalGrowth-RangeType1-SizeSTL.csv",sep='')
percentCOverRangesTmp <- read.csv(pcorFilename,row.names=1)
percentCOverRangesTmp$Group <- "Terminal Growth"
percentCOverRanges <- rbind(percentCOverRanges,percentCOverRangesTmp)
pcorFilename <- paste(motifDataDirectory,"RawKmerFreqs/CPercentPerRange-SegmentalGrowth-RangeType1-SizeSTL.csv",sep='')
percentCOverRangesTmp <- read.csv(pcorFilename,row.names=1)
percentCOverRangesTmp$Group <- "Segmental Growth"
percentCOverRanges <- rbind(percentCOverRanges,percentCOverRangesTmp)
pcorFilename <- paste(motifDataDirectory,"RawKmerFreqs/CPercentPerRange-ApicalGrowth-RangeType1-SizeSTL.csv",sep='')
percentCOverRangesTmp <- read.csv(pcorFilename,row.names=1)
percentCOverRangesTmp$Group <- "Apical Growth Model"
percentCOverRanges <- rbind(percentCOverRanges,percentCOverRangesTmp)

percentCOverRanges$SeqLen <- 0
arborInds <- percentCOverRanges$Group%in%c("Axon","Dendrite","ApicalDendrite")
percentCOverRanges[arborInds] <- rownames(percentCOverRanges)[!arborInds]

rangeNames <- colnames(percentCOverRanges)
maxs <- as.numeric(gsub("X","",rangeNames))
if (absolute){
  mins <- c(1,maxs[-length(maxs)]+1)
}else{
  mins <- c(0,maxs[-length(maxs)])
}
percentCOverRanges <- cbind(percentCOverRanges,motifMetaData[rownames(percentCOverRanges),"SeqLen",drop=F])

percentCOverRanges_long <- reshape(percentCOverRanges,varying=list(rangeNames),times=rangeNames,direction="long",idvar="SeqName",ids=rownames(percentCOverRanges),timevar="PositionRange",v.names="PercentC")
percentCOverRanges_long$RangeMin <- 0
percentCOverRanges_long$RangeMax <- 0
posRanges <- c()
for (i in 1:length(rangeNames)){
  posRanges[i] <- paste(mins[i],maxs[i],sep="-")
  percentCOverRanges_long[percentCOverRanges_long$PositionRange==rangeNames[i],"RangeMin"] <- mins[i]
  percentCOverRanges_long[percentCOverRanges_long$PositionRange==rangeNames[i],"RangeMax"] <- maxs[i]
  percentCOverRanges_long[percentCOverRanges_long$PositionRange==rangeNames[i],"PositionRange"] <- posRanges[i]
}
percentCOverRanges_long_mod <- percentCOverRanges_long[percentCOverRanges_long$SeqLen > percentCOverRanges_long$RangeMin,]
newNames <- factor(percentCOverRanges_long_mod$PositionRange,levels=posRanges)
percentCOverRanges_long_mod$PositionRange <- newNames

# Subset to dendrites only
dendCOverRanges <- subset(percentCOverRanges_long_mod,SeqName%in%rownames(dendriteCFreq))
axonCOverRanges <- subset(percentCOverRanges_long_mod,SeqName%in%rownames(axonCFreq))

# Look at all at once
CairoWin()
ggplot(dendCOverRanges,aes(x = SeqLen, y = PercentC, colour=PositionRange, fill=PositionRange))+
  stat_smooth(method = "loess", span=.6, se = TRUE,level = 0.95)+
  #coord_cartesian(xlim=c(0,250), ylim = c(.3, .7))+
  coord_cartesian(xlim=c(0,250), ylim = c(0, 1))+
  labs(title = "Dendrite %C Over Position Ranges",colour="Position Range",fill="Position Range",x="Sequence Length", y="Percent C")

ggplot(axonCOverRanges,aes(x = SeqLen, y = PercentC, colour=PositionRange, fill=PositionRange))+
  stat_smooth(method = "loess", span=.6, se = FALSE,level = 0.95)+
  #coord_cartesian(xlim=c(0,250), ylim = c(.3, .7))+
  coord_cartesian(xlim=c(0,250), ylim = c(0, 1))+
  labs(title = "Axon %C Over Position Ranges",colour="Position Range",fill="Position Range",x="Sequence Length", y="Percent C")

axonPCRelModel <- glm(PercentC~PositionRange*SeqLen,data=axonCOverRanges)
dendPCRelModel <- glm(PercentC~PositionRange*SeqLen,data=dendCOverRanges)

percentCModel <- glm(PercentC~PositionRange*SeqLen,data=dendCOverRanges)
percentCRelModel <- glm(PercentC~PositionRange*SeqLen,data=dendCOverRanges)
percentCModel_nobegin <- glm(PercentC~PositionRange*SeqLen,data=subset(dendCOverRanges_long_mod,PositionRange!="1-20"))
percentCRelModel_nobegin <- glm(PercentC~PositionRange*SeqLen,data=subset(dendCOverRanges,PositionRange!="0.15-0.3"))
CairoWin()
plot(percentCModel_nobegin)
    
# Look at first 20 by sequence length
ggplot(dendCOverRanges,aes(x = SeqLen, y = PercentC))+
  stat_smooth(method = "loess", span=.5, se = TRUE,level = 0.95)+
  coord_cartesian(xlim=c(0,250), ylim = c(.2, .7))+
  labs(colour="Length Range",fill="Length Range",x="Sequence Length", y="Percent C", main="First 20 positions")

# GLM of data
glm_dendPCOverRange <- glm(PercentC~SeqLen*PositionRange,data=dendCOverRanges)
summary(glm_dendPCOverRange)
glm_axonPCOverRange <- glm(PercentC~SeqLen*PositionRange,data=axonCOverRanges)
summary(glm_axonPCOverRange)

glm_dendPCOverRange <- glm(PercentC~SeqLen*PositionRange,data=subset(dendCOverRanges,PositionRange!="1-20"))
summary(glm_dendPCOverRange)
glm_dendPCOverRange <- glm(PercentC~SeqLen+PositionRange,data=subset(dendCOverRanges,PositionRange!="1-20"))
summary(glm_dendPCOverRange)
glm_axonPCOverRange <- glm(PercentC~SeqLen*PositionRange,data=subset(axonCOverRanges,PositionRange!="1-20"))
summary(glm_axonPCOverRange)

## Generate sequence length bins and plot bars by position range
seqLenRangeMins <- c(18,61,121,181,221)
seqLenRangeMaxs <- c(60,120,180,220,280)
percentCOverRanges_long_mod$SeqLenRange <- "Over 280"
seqLenRanges <- c()
for (i in 1:length(seqLenRangeMins)){
  seqLenRanges[i] <- paste(seqLenRangeMins[i],seqLenRangeMaxs[i],sep="-")
  inds <- percentCOverRanges_long_mod$SeqLen>=seqLenRangeMins[i]&percentCOverRanges_long_mod$SeqLen<=seqLenRangeMaxs[i]
  percentCOverRanges_long_mod[inds,"SeqLenMin"] <- seqLenRangeMins[i]
  percentCOverRanges_long_mod[inds,"SeqLenMax"] <- seqLenRangeMaxs[i]
  percentCOverRanges_long_mod[inds,"SeqLenRange"] <- seqLenRanges[i]
}
seqLenRanges[i+1] <- "Over 280"
percentCOverRanges_long_mod$SeqLenRange <- factor(percentCOverRanges_long_mod$SeqLenRange,seqLenRanges)

# Subset to dendrites only
dendCOverRanges <- subset(percentCOverRanges_long_mod,SeqName%in%rownames(dendriteCFreq))
axonCOverRanges <- subset(percentCOverRanges_long_mod,SeqName%in%rownames(axonCFreq))

# Group middle ranges
percentCOverRanges_long_mod2 <- percentCOverRanges_long_mod
vals <- as.character(percentCOverRanges_long_mod2$PositionRange)
newPosRanges <- c(posRanges[1],"Middle",posRanges[length(posRanges)])
newVals <- as.character(percentCOverRanges_long_mod2$PositionRange)
newVals[!newVals%in%newPosRanges] <- "Middle"
percentCOverRanges_long_mod2$PositionRange <- factor(newVals,newPosRanges)
dendCOverRanges <- subset(percentCOverRanges_long_mod2,SeqName%in%rownames(dendriteCFreq))
axonCOverRanges <- subset(percentCOverRanges_long_mod2,SeqName%in%rownames(axonCFreq))

CairoWin()
ggplot(axonCOverRanges,aes(x = PositionRange, y = PercentC, fill=SeqLenRange))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  labs(title="Dendrite Percent C over ranges",colour="Sequence Length Range",fill="Sequence Length Range",x="Position Range", y="Percent C")

CairoWin()
ggplot(axonCOverRanges,aes(x = SeqLenRange, y = PercentC, fill=PositionRange))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  labs(title="Axon Percent C over ranges",fill="Position Range",x="Sequence Length Range", y="Percent C")

lm_axonC <- glm(PercentC~SeqLenRange*PositionRange,data=axonCOverRanges)
lm_dendriteC <- glm(PercentC~SeqLenRange*PositionRange,data=dendCOverRanges)
anova(lm_axonC)
anova(lm_dendriteC)

tmp<-TukeyHSD(aov(PercentC~SeqLenRange*PositionRange,data=axonCOverRanges))

#### %C over positions (not binned) ####
datasetTitle <- "NeuroMorpho.Org"
cPosFilename <- paste(motifDataDirectory,"RawKmerFreqs/CPercentPerPos-NM_SpurLen2D-SizeSTL.csv",sep='')
percentCByPos <- read.csv(cPosFilename,stringsAsFactor=F)
percentCByPos$Group <- motifMetaData[percentCByPos$Sequence,"ArborType"]
percentCByPos$Group[percentCByPos$Group=="BasalDendrite"] <- "Dendrite"
#datasetTitle <- "Segmental Growth"
cPosFilename <- paste(motifDataDirectory,"/CPercentPerPos-SegmentalGrowth-SizeSTL.csv",sep='')
percentCByPosTmp <- read.csv(cPosFilename,stringsAsFactor=F)
percentCByPosTmp$Group <- "Segmental Growth"
percentCByPos <- rbind(percentCByPos,percentCByPosTmp)
#datasetTitle <- "Terminal Growth"
#cPosFilename <- paste(motifDataDirectory,"/CPercentPerPos-TerminalGrowth-SizeSTL.csv",sep='')
cPosFilename <- paste(motifDataDirectory,"/CPercentPerPos-BiasedTerminalGrowth-SizeSTL.csv",sep='')
percentCByPosTmp <- read.csv(cPosFilename,stringsAsFactor=F)
percentCByPosTmp$Group <- "Terminal Growth"
percentCByPos <- rbind(percentCByPos,percentCByPosTmp)
rm(percentCByPosTmp)

datasetTitle <- "Combined"

#percentCByPos <- read.csv(cPosFilename)

# Assign sequence length group
#percentCByPos$SeqLenGrp <- "18-30"
#percentCByPos$SeqLenGrp[percentCByPos$Length>30] <- "31-60"
#percentCByPos$SeqLenGrp[percentCByPos$Length>60] <- "61-100"
#percentCByPos$SeqLenGrp[percentCByPos$Length>100] <- "101-150"
#percentCByPos$SeqLenGrp[percentCByPos$Length>150] <- "151+"
#percentCByPos$SeqLenGrp <- factor(percentCByPos$SeqLenGrp,levels=c("18-30","31-60","61-100","101-150","151+"),ordered=T)

# Get rows that are dendrites or growth from a particular range of lengths
percentCByPosSubset <- subset(percentCByPos,Group=="Dendrite"&Length<=150)
percentCByPosSubset$Label <- "18-50"
percentCByPosSubset$Label[percentCByPosSubset$Length>50] <- "51-90"
percentCByPosSubset$Label[percentCByPosSubset$Length>90&percentCByPosSubset$Length<=150] <- "91-150"

# Generate weights for each sequence length so growth sets seq length distribution
# match dendrite length distribution
dendLengths <- subset(percentCByPosSubset,Position==18)$Length
dendLengthCounts <- aggregate(dendLengths,by=list(dendLengths),length)
rownames(dendLengthCounts) <- dendLengthCounts[,1]
dendLengthCounts$weight <- dendLengthCounts$x*max(dendLengths)/dendLengthCounts[,1]

percentCByPosTmp <- subset(percentCByPos,Group%in%c("Terminal Growth","Segmental Growth")&Length%in%dendLengths)
percentCByPosTmp <- percentCByPosTmp[sample(1:nrow(percentCByPosTmp),nrow(percentCByPosTmp)/6,prob=dendLengthCounts[as.character(percentCByPosTmp$Length),"weight"]),]
percentCByPosTmp$Label <- percentCByPosTmp$Group
percentCByPosSubset <- rbind(percentCByPosSubset,percentCByPosTmp)

percentCByPosSubset$Label <- factor(percentCByPosSubset$Label,levels=c("18-50","51-90","91-150","Terminal Growth","Segmental Growth"),ordered=T)
percentCByPosSubset$RelPosition <- percentCByPosSubset$Position/percentCByPosSubset$Length
#pcPalette <- c(rgb(0,0.1,0.5),rgb(0,0.14,0.57),rgb(0,0.16,0.64),"#555555","#999999")
pcPalette <- c("#321093","#2222CC","#204AFF","#666666","#999999")


png(filename=paste(motifDataDirectory,"PercentCByRelPos-wSE-DendGrowthCombo-Span.4_CV7.png",sep=""),
    width=800,height=600)
pdf(paste(motifDataDirectory,"PercentCByRelPos-wSE-DendGrowthCombo-Span.4_CV7.pdf",sep=""),
    width=800,height=600)
#Cairo(file=paste(motifDataDirectory,"PercentCByRelPos-wSE-DendGrowthCombo-Span.4_CV7_Cairo.png",sep=""),
#      type="png",units="in",width=8,height=6,pointsize=12,dpi=300)
cByPosPlot <- ggplot(sample.rows(percentCByPosSubset,nrow(percentCByPosSubset)/4),aes(x=RelPosition,y=IsC,group=Label,colour=Label,fill=Label))+
  stat_smooth(method = "loess", span=.4, se = T,level = 0.95)+
  scale_colour_manual(values=pcPalette)+
  scale_fill_manual(values=pcPalette)+
  labs(colour="Length Range",fill="Length Range",x="Relative Position", y="Percent C", title=paste("%C Over Positions - ",datasetTitle))+
  getTheme()
ggsave(cByPosPlot,file=paste(motifDataDirectory,"PercentCByRelPos-wSE-DendGrowthCombo-Span.4_CV7_2.pdf",sep=""))


## The normal way?
percentCByPos$RelPosition <- percentCByPos$Position/percentCByPos$Length

# Plot for all
png(paste(motifDataDirectory,"PercentCByPos-",gsub(" ","",datasetTitle),"-Span.4.png",sep=""),width=800,height=600)
ggplot(percentCByPos,aes(x=Position,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.4, se = F,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Position", y="Percent C", title=paste("%C Over Positions - ",datasetTitle))
dev.off()

# Plot for all, relative
png(paste(motifDataDirectory,"PercentCByRelativePos-",gsub(" ","",datasetTitle),"-Span.4.png",sep=""),width=800,height=600)
ggplot(sample.rows(percentCByPos,.4),aes(x=RelPosition,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.4, se = F,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Position", y="Percent C", title=paste("%C Over Positions - ",datasetTitle))
dev.off()

# Plot for all, relative, with SE
png(paste(motifDataDirectory,"PercentCByRelativePos-wSE-",gsub(" ","",datasetTitle),"-Span.4.png",sep=""),width=800,height=600)
ggplot(sample.rows(percentCByPos,.5),aes(x=RelPosition,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.4, se = T,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Position", y="Percent C", title=paste("%C Over Positions - ",datasetTitle))
dev.off()

# Plot for axons
png(paste(motifDataDirectory,"PercentCByPos-Axon-Span.1.png",sep=""),width=800,height=600)
ggplot(subset(percentCByPos,Group=="Axon"),aes(x=Position,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.1, se = F,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Position", y="Percent C", title="%C Over Positions - Axons")
dev.off()
  
# Plot for apical dendrites
png(paste(motifDataDirectory,"PercentCByPos-ApicalDendrite-Span.1.png",sep=""),width=800,height=600)
ggplot(subset(percentCByPos,Group=="ApicalDendrite"&Length<=100),aes(x=Position,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.1, se = F,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Position", y="Percent C", title="%C Over Positions - Apical Dendrites")
dev.off()

# Plot for dendrites
png(paste(motifDataDirectory,"PercentCByPos-Dendrite-Span.1.png",sep=""),width=800,height=600)
#ggplot(subset(percentCByPos[sample(1:nrow(percentCByPos),size=nrow(percentCByPos)/2,replace=T),],Group=="Dendrite"),aes(x=Position,y=IsC,colour=SeqLenGrp))+
ggplot(subset(percentCByPos,Group=="Dendrite"),aes(x=Position,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.1, se = F,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Position", y="Percent C", title="%C Over Positions - Dendrites")
dev.off()

# Early section
png(paste(motifDataDirectory,"PercentCByPos-Dendrite-Span.4_UpTo40.png",sep=""),width=800,height=600)
#ggplot(subset(percentCByPos[sample(1:nrow(percentCByPos),size=nrow(percentCByPos)/2,replace=T),],Group=="Dendrite"),aes(x=Position,y=IsC,colour=SeqLenGrp))+
ggplot(subset(percentCByPos,Group=="Dendrite"&Position<=40),aes(x=Position,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.4, se = F,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Position", y="Percent C", title="%C Over Positions - Dendrites")
dev.off()

# The same, but this time with relative positions
# Plot for axons
useSE <- T
seStr <- ''
if (useSE) seStr <- '-wSE'

png(paste(motifDataDirectory,"PercentCByRelativePos-Axon-Span.4.png",sep=""),width=800,height=600)
ggplot(sample.rows(subset(percentCByPos,Group=="Axon"),.7),aes(x=Position/Length,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.4, se = F,level = 0.95, aes(fill = SeqLenGrp))+
  labs(colour="Length Range",fill="Length Range",x="Relative Position", y="Percent C", title="%C Over Positions - Axons")
dev.off()

# Plot for apical dendrites
png(paste(motifDataDirectory,"PercentCByRelativePos-ApicalDendrite-Span.4.png",sep=""),width=800,height=600)
ggplot(subset(percentCByPos,Group=="ApicalDendrite"&Length<=100),aes(x=Position/Length,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.4, se = F,level = 0.95, aes(fill = SeqLenGrp))+
  labs(colour="Length Range",fill="Length Range",x="Relative Position", y="Percent C", title="%C Over Positions - Apical Dendrites")
dev.off()

# Plot for dendrites
png(paste(motifDataDirectory,"PercentCByRelativePos-Dendrite-Span.4.png",sep=""),width=800,height=600)
ggplot(sample.rows(subset(percentCByPos,Group=="Dendrite"),.9),aes(x=Position/Length,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.4, se = F,level = 0.95, aes(fill = SeqLenGrp))+
  labs(colour="Length Range",fill="Length Range",x="Relative Position", y="Percent C", title="%C Over Positions - Dendrites")
dev.off()

# Pyramidal dendrites
pyrDendSeqs <- subset(percentCByPos,Group=="Dendrite"&Sequence%in%rownames(subset(motifMetaData,Class2=="Pyramidal cell")))
pyrDendSeqs$SeqLenGrp <- "18-30"
pyrDendSeqs$SeqLenGrp[pyrDendSeqs$Length>30] <- "31-60"
pyrDendSeqs$SeqLenGrp[pyrDendSeqs$Length>60] <- "61+"
pyrDendSeqs$SeqLenGrp <- factor(pyrDendSeqs$SeqLenGrp,levels=c("18-30","31-60","61+",ordered=T))
png(paste(motifDataDirectory,"PercentCByRelativePos-wSE-PyramidalDendrite-Span.4.png",sep=""),width=800,height=600)
ggplot(subset(pyrDendSeqs,Length<120),aes(x=Position/Length,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.4, se = T,level = 0.95, aes(fill = SeqLenGrp))+
  labs(colour="Length Range",fill="Length Range",x="Relative Position", y="Percent C", title="%C Over Positions - Dendrites")
dev.off()

## Surrogates
cPosFilename <- paste(motifDataDirectory,"RawKmerFreqs/CPercentPerPos-TerminalGrowth-SizeSTL.csv",sep='')
growthPCByPos <- read.csv(cPosFilename)
growthPCByPos <- growthPCByPos[,-1]
growthPCByPos$Group <- "Terminal Growth"

cPosFilename <- paste(motifDataDirectory,"RawKmerFreqs/CPercentPerPos-SegmentalGrowth-SizeSTL.csv",sep='')
growthPCByPos2 <- read.csv(cPosFilename)
growthPCByPos2 <- growthPCByPos2[,-1]
growthPCByPos2$Group <- "Segmental Growth"

growthPCByPos <- rbind(growthPCByPos,growthPCByPos2)

# Assign sequence length group
growthPCByPos$SeqLenGrp <- "18-30"
growthPCByPos$SeqLenGrp[growthPCByPos$Length>30] <- "31-60"
growthPCByPos$SeqLenGrp[growthPCByPos$Length>60] <- "61-100"
growthPCByPos$SeqLenGrp[growthPCByPos$Length>100] <- "101-150"
growthPCByPos$SeqLenGrp[growthPCByPos$Length>150] <- "151+"
growthPCByPos$SeqLenGrp <- factor(growthPCByPos$SeqLenGrp,levels=c("18-30","31-60","61-100","101-150","151+"),ordered=T)

png(paste(motifDataDirectory,"PercentCByPos-Terminal.png",sep=""),width=800,height=600)
ggplot(subset(growthPCByPos,Group=="Terminal Growth"),aes(x=Position,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.5, se = F,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Position", y="Percent C", title="%C Over Positions - Terminal Growth")
dev.off()

png(paste(motifDataDirectory,"PercentCByPos-Segmental.png",sep=""),width=800,height=600)
ggplot(subset(growthPCByPos,Group=="Segmental Growth"),aes(x=Position,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.5, se = F,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Position", y="Percent C", title="%C Over Positions - Segmental Growth")
dev.off()

png(paste(motifDataDirectory,"PercentCByRelativePos-wSE-Terminal.png",sep=""),width=800,height=600)
ggplot(subset(growthPCByPos,Group=="Terminal Growth"),aes(x=Position/Length,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.5, se = T,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Relative Position", y="Percent C", title="%C Over Positions - Terminal Growth")
dev.off()

png(paste(motifDataDirectory,"PercentCByRelativePos-wSE-Segmental.png",sep=""),width=800,height=600)
ggplot(subset(growthPCByPos,Group=="Segmental Growth"),aes(x=Position/Length,y=IsC,colour=SeqLenGrp))+
  stat_smooth(method = "loess", span=.5, se = T,level = 0.95)+
  labs(colour="Length Range",fill="Length Range",x="Relative Position", y="Percent C", title="%C Over Positions - Segmental Growth")
dev.off()

#### Percentile Ranks - Monomers, Dimers, and Trimers ####

# Set data source
myData <- prDataB8Combo
mySurrogateData <- prSurrogateDataB8Combo_40
#myData <- prDataB8STL_40
#mySurrogateData <- prSurrogateDataB8STL_40

seqLengthRanges <- list(c(0,35),c(36,60),c(61,100),c(101,350))

ylimsByK <- list(c(0,1),c(0,0.9),c(0.2,0.7))
for (k in 1:3){
  kData <- myData[[k]]
  #kSurrogateData <- mySurrogateData[[k]]

  validKmers <- removeATT("STL",colnames(kData))
  kData <- kData[,validKmers]
    
  # Convert from wide to long
  myDataLong <- reshape(kData,direction="long",varying=list(colnames(kData)),times=colnames(kData),idvar="SeqName",ids=rownames(kData),timevar="Kmer",v.names="PercentileRank")
  myDataLong <- myDataLong[myDataLong$SeqName%in%allNeuriteNames,]
  myDataLong$ArborType <- motifMetaData[myDataLong$SeqName,"ArborType"]
  myDataLong[myDataLong$ArborType=="BasalDendrite","ArborType"] <- "Dendrite"
  
  # Convert from wide to long
  #mySurrogateDataLong <- reshape(kSurrogateData,direction="long",varying=list(colnames(kSurrogateData)),times=colnames(kSurrogateData),idvar="SeqName",ids=rownames(kSurrogateData),timevar="Kmer",v.names="PercentileRank")
  #mySurrogateDataLong <- mySurrogateDataLong[mySurrogateDataLong$SeqName%in%allNeuriteNames,]
  #mySurrogateDataLong$ArborType <- motifMetaData[mySurrogateDataLong$SeqName,"ArborType"]
  #mySurrogateDataLong[mySurrogateDataLong$ArborType=="BasalDendrite","ArborType"] <- "Dendrite"

  for (seqLenthRange in seqLenthRanges){
    myDataLongSub <- subset(myDataLong,SeqLen >= seqLengthRange[1] & SeqLen <= seqLengthRange[2])
    #myDataLongSub <- myDataLong
    
    # Determine kmer averages to sort in ascending order
    kmerMeans <- aggregate(myDataLongSub$PercentileRank,by=list(myDataLongSub$Kmer),FUN=mean)
    kmerFactor <- factor(myDataLongSub$Kmer,levels=kmerMeans[order(kmerMeans[,2]),1])
    myDataLongSub$Kmer <- kmerFactor

    # Plot
    #CairoWin()
    
    ggplot(myDataLongSub,aes(Kmer,PercentileRank,fill=ArborType))+
      stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
      stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
      scale_fill_manual(values=withApicalPal)+
      coord_cartesian(ylim=ylimsByK[[k]])+
      theme(axis.text.x = element_text(angle = 90, hjust = 0))
    # Box&whisker plot
    ggplot(myDataLongSub,aes(Kmer,PercentileRank,fill=ArborType))+
      geom_boxplot()
      scale_fill_manual(values=withApicalPal)+
      theme(axis.text.x = element_text(angle = 90, hjust = 0))
    dev.off()
  }
}


nonInterestingTrimers <- c("TAC","L-TTA","TTA","L-CTC","TTC","L-AAC","L-TTC","L-CTA","TAT")
modestlyInterestingTrimers <- c("CAC","L-AAT","L-AAT","L-TTT","TAA","L-CTT")
ggplot(subset(myDataLong,!Kmer%in%union(nonInterestingTrimers,modestlyInterestingTrimers)),aes(Kmer,PercentileRank,fill=ArborType))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  scale_fill_manual(values=withApicalPal)+
  coord_cartesian(ylim=ylimsByK[[k]])+
  theme(axis.text.x = element_text(angle = 90, hjust = 0))

# Same, but for standard deviations instead of means
CairoWin()
ggplot(subset(myDataLong,!Kmer%in%union(nonInterestingTrimers,modestlyInterestingTrimers)),aes(Kmer,PercentileRank,fill=ArborType))+
  stat_summary(fun.y=sd, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=sd, fun.ymin=lowsesd, fun.ymax=highsesd, geom="errorbar", position="dodge",color = 'black', size=.5)+
#  coord_cartesian(ylim=c(0,.3))+
  theme(axis.text.x = element_text(angle = 90, hjust = 0))

# Plot %C PercentileRanks
percentRankC <- myData[[1]]
percentRankC$ArborType <- motifMetaData[rownames(percentRankC),"ArborType"]
percentRankC[percentRankC$ArborType=="BasalDendrite","ArborType"] <- "Dendrite"
ggplot(percentRankC,aes(ArborType,C,fill=ArborType))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  #  coord_cartesian(ylim=c(0,.3))+
  scale_fill_manual(values=withApicalPal)+
#  theme(axis.text.x = element_text(angle = 90, hjust = 0))+
  labs(y="C Percentile Rank")

# Plot %C Raw
rawPercentC <- realCFreqs
rawPercentC$ArborType <- motifMetaData[rownames(rawPercentC),"ArborType"]
rawPercentC[rawPercentC$ArborType=="BasalDendrite","ArborType"] <- "Dendrite"
ggplot(rawPercentC,aes(ArborType,C,fill=ArborType))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  coord_cartesian(ylim=c(.25,.47))+
  scale_fill_manual(values=withApicalPal)+
#  theme(axis.text.x = element_text(angle = 90, hjust = 0))+
  labs(y="Percent C")

#### Most representative neurons ####
allData <- cbind(cbind(myData[[1]],myData[[2]]),myData[[3]])
validKmers <- removeATT("STL",colnames(allData))
axonAll <- allData[intersect(rownames(allData),axonNames),validKmers]
#apicAll <- allData[pyrApicalNames,validKmers]
apicAll <- allData[intersect(rownames(allData),apicalNames),validKmers]
dendAll <- allData[intersect(rownames(allData),dendriteNames),validKmers]
pyrAxonAll <- allData[intersect(rownames(allData),pyrAxonNames),validKmers]
pyrDendAll <- allData[intersect(rownames(allData),pyrDendriteNames),validKmers]
#axonMeans <- apply(axonAll,2,)
#apicMeans <- apply(apicAll,2,mean)
#dendMeans <- apply(dendAll,2,mean)
#weights <- c(1,rep(.5,9),rep(.2,39))
weights <- c(1,rep(1.2,9),rep(1.2,39))
axonZ <- scale(axonAll)
apicZ <- scale(apicAll)
dendZ <- scale(dendAll)
pyrAxonZ <- scale(pyrAxonAll)
pyrDendZ <- scale(pyrDendAll)

axonVals <- apply(axonZ,1,function(x,weights){sqrt(sum((x*weights)^2))},weights)
apicVals <- apply(apicZ,1,function(x,weights){sqrt(sum((x*weights)^2))},weights)
dendVals <- apply(dendZ,1,function(x,weights){sqrt(sum((x*weights)^2))},weights)
pyrAxonVals <- apply(pyrAxonZ,1,function(x,weights){sqrt(sum((x*weights)^2))},weights)
pyrDendVals <- apply(pyrDendZ,1,function(x,weights){sqrt(sum((x*weights)^2))},weights)

# Show names and values
sort(axonVals)[1:10]
sort(apicVals)[1:10]
sort(dendVals)[1:10]
sort(pyrAxonVals)[1:10]
sort(pyrDendVals)[1:10]

# Show metadata for top 5 neurites
motifMetaData[names(sort(axonVals)[1:5]),c("BrainRegion","Class2","Archive","SeqLen")]
motifMetaData[names(sort(apicVals)[1:5]),c("BrainRegion","Class2","Archive","SeqLen")]
motifMetaData[names(sort(dendVals)[1:10]),c("BrainRegion","Class2","Archive","SeqLen")]
motifMetaData[names(sort(pyrAxonVals)[1:5]),c("Region2","Archive","SeqLen")]
motifMetaData[names(sort(pyrDendVals)[1:5]),c("Region2","Archive","SeqLen")]

# Show motif values for top 5
axonZ[names(sort(axonVals)[1:5]),c("C","AA","TA","CT","TCC","CAT","ACT")]
apicZ[names(sort(apicVals)[1:5]),c("C","TA","CA","AT","ACT","AAT","CAA")]
dendZ[names(sort(dendVals)[1:5]),c("C","AA","TA","CT","CCT","ACC","TCT")]

axonMeans <- apply(axonAll,2,mean)
axonMeans[c("C","AA","TA","CT","TCC","CAT","ACT")]
apicMeans <- apply(apicAll,2,mean)
apicMeans[c("C","TA","CA","AT","ACT","AAT","CAA")]
dendMeans <- apply(dendAll,2,mean)
dendMeans[c("C","AA","TA","CT","CCT","ACC","TCT")]

#oi53rpy1-Axon - Pyramidal
#C010600C1-Axon  - Basket
#BE71E-Axon (Kawaguchi - Basket)
#Vn06202006-0-B-Axon (Yuste - Pyramidal)
axonZ[names(sort(axonVals)[27]),c("C","AA","TA","CT","TCC","CAT","ACT")]
selectAxons <- names(sort(axonVals)[1:20])
selectAxons <- "n262-Axon"
cbind(axonAll[selectAxons,c("C","AA","TA","CT","TCC","CAT","ACT")],SeqLen=motifMetaData[selectAxons,"SeqLen"])


selectDends <- "86MV-BasalDendrite"
selectDends <- names(sort(dendVals)[1:10])
                    
dendZ["86MV-BasalDendrite",c("C","AA","TA","CT","TCT","ACT","ACC")]
dendAll["86MV-BasalDendrite",c("C","AA","TA","CT","TCT","ACT","ACC")]
dendZ[names(sort(dendVals)[27]),c("C","AA","TA","CT","TCC","CAT","ACT")]


selectDends <- names(sort(dendVals)[4:30])
cbind(dendAll[selectDends,c("C","AA","TA","CT","TCC","CAT","ACT")],SeqLen=motifMetaData[selectDends,"SeqLen"])

cbind(dendAll[selectDends,c("C","AA","TA","CT","AT","CA")],SeqLen=motifMetaData[selectDends,"SeqLen"])

## Picking for dimer/trimer slide
# 32-1-3-BasalDendrite (L=23) for dendrite example showing AA, TA arborizing regions
# n262-Axon (L=45) for axon example showing AA, TA arborizing regions

# Pick examples with axon high ACT/ACC, dendrite-high ACC/ACT 
sample.rows(subset(axonAll,ACT>.65&ACC<.3&AC>.65)[,c("AC","CT","ACT","ACC")],10)

tmp<-sample.rows(subset(dendAll,ACT<.4&ACC>.55&AC>.65)[,c("AC","CT","ACT","ACC")],10)
usedMetaData[rownames(tmp),c("Class2","SeqLen")]

#### Select neurons based on kmer counts and/or PRs ####
# Load Kmer counts
kmerFreqs <- list()
kmerCounts <- list()
for (k in 1:3){
  kmerFreqs[[k]] <- getKmerFreqs(k,dataset=dataset,travOrder="STL")
  kmerFreqs[[k]] <- kmerFreqs[[k]][rownames(kmerFreqs[[k]])%in%rownames(usedMetaData),,drop=F]
  kmerCounts[[k]] <- as.data.frame(t(mapply(
    function(arr,len){return(round(arr*len))},
    as.data.frame(t(kmerFreqs[[k]])),
    usedMetaData[rownames(kmerFreqs[[k]]),"SeqLen"]-k+1)))
  colnames(kmerCounts[[k]]) <- colnames(kmerFreqs[[k]])
  kmerCounts[[k]]$ArborType <- usedMetaData[rownames(kmerCounts[[k]]),"ArborType"]
  kmerCounts[[k]]$SeqLen <- usedMetaData[rownames(kmerCounts[[k]]),"SeqLen"]
}

# Getting axons with more ACT than ACC, and dendrites with more ACC than ACT
selTrimerAxons <- subset(kmerCounts[[3]],ArborType=="Axon"&ACT>ACC)[,c("SeqLen","ACT","ACC")]
selTrimerDends <- subset(kmerCounts[[3]],ArborType=="Dendrite"&ACC>ACT)[,c("SeqLen","ACT","ACC")]
selTrimerAxonNeuronNames <- gsub("-Axon","",rownames(selTrimerAxons))
selTrimerDendNeuronNames <- gsub("-(Basal)?Dendrite","",rownames(selTrimerDends))
inBoth <- intersect(selTrimerAxonNeuronNames,selTrimerDendNeuronNames)

# Getting axons and dendrites with more CT than CA
sample.rows(subset(kmerCounts[[2]],ArborType=="Dendrite"&CT>TT&SeqLen<50),20)[,c("CT","TT","SeqLen")]
#subset(kmerCounts[[2]][with(kmerCounts[[2]],order(CT,TT)),],ArborType=="Dendrite"&CT>TT)[1:10,c("CT","TT","SeqLen")]
selDimerDends <- subset(kmerCounts[[2]],ArborType=="Dendrite"&CT>(TT+4)&SeqLen<60)
selDendNeuronNames <- gsub("-(Basal)?Dendrite","",rownames(selDimerDends))
selDimerAxons <- subset(kmerCounts[[2]],ArborType=="Axon"&CT>(TT+4)&SeqLen<160)
selAxonNeuronNames <- gsub("-Axon","",rownames(selDimerAxons))
selComboNeuronNames <- intersect(selAxonNeuronNames,selDendNeuronNames)
#sample(selComboNeuronNames
# Both CT > CA and AA PR > .6
selDimerDends <- subset(kmerCounts[[2]],ArborType=="Dendrite"&CT>(TT+4)&SeqLen<60&SeqLen>26)
selDimerDends <- selDimerDends[rownames(selDimerDends)%in%rownames(subset(prDataB8Combo[[2]],AA>.6&AT<.4&CT>.75&TT<.4)),]
selDendNeuronNames <- gsub("-(Basal)?Dendrite","",rownames(selDimerDends))
selDimerAxons <- subset(kmerCounts[[2]],ArborType=="Axon"&CT>(TT+4)&SeqLen<160)
selDimerAxons <- selDimerAxons[rownames(selDimerAxons)%in%rownames(subset(prDataB8Combo[[2]],AA>.6&AT<.4&CT>.75&TT<.4)),]
selAxonNeuronNames <- gsub("-Axon","",rownames(selDimerAxons))
selComboNeuronNames <- intersect(selAxonNeuronNames,selDendNeuronNames)
usedMetaData[paste(selComboNeuronNames,"-Axon",sep=""),c("Archive","Class2")]
selectedNeuron <- "11707D-63X" # 0 TT for both dendrites and axons; Maccaferri martinotti cell (cortex)
selectedNeuron <- "C190898A-I1" # TT > 0; Markram bitufted cell (cortex)
prDataB8Combo[[2]][paste(selectedNeuron,"-Axon",sep=""),]
kmerCounts[[2]][paste(selectedNeuron,"-Axon",sep=""),]
prDataB8Combo[[2]][paste(selectedNeuron,"-Dendrite",sep=""),]
kmerCounts[[2]][paste(selectedNeuron,"-Dendrite",sep=""),]
"C170897A-I1"
"050113026"
"11707D-63X"

# Kmer PRs - high AA, low but not 0 AT
# Specifically, AA_PR > .7, AA > AT + 3, AT > 0, for both axon and dendrite
selAAAxons <- subset(kmerCounts[[2]],ArborType=="Axon"&AA>AT+1&AT>0)[,c("SeqLen","AA","AT")]
selAADends <- subset(kmerCounts[[2]],ArborType=="Dendrite"&AA>AT&AT>0)[,c("SeqLen","AA","AT")]

selAAPRAxons <- subset(prDataB8Combo[[2]][rownames(selAAAxons),],AA>.7)
selAAPRDends <- subset(prDataB8Combo[[2]][rownames(selAADends),],AA>.7)

selAAAxons <- cbind(selAAAxons[rownames(selAAPRAxons),],selAAPRAxons$AA)
selAADends <- cbind(selAADends[rownames(selAAPRDends),],selAAPRDends$AA)

inBothAA <- intersect(gsub("-Axon","",rownames(selAAAxons)),gsub("-(Basal)?Dendrite","",rownames(selAADends)))

#### Neuron class comparisons ####

# Axons - cortical pyramidal vs cortical interneuron
ncPyramidalSpec <- list(ArborType="Axon",ExperCond="Control",BrainRegion="Neocortex",Class2="Pyramidal cell")
ncInterneuronSpec <- list(ArborType="Axon",ExperCond="Control",BrainRegion="Neocortex",Class1="Interneuron")
specifications <- list(Pyramidal=ncPyramidalSpec,Interneuron=ncInterneuronSpec)
classYlims <- list(0,ylimsByK[[2]],c(.1,.75))

# Apical dendrites - cortical vs HC CA1 vs HC CA3
ncApicalSpec <- list(ArborType="ApicalDendrite",ExperCond="Control",BrainRegion="Neocortex",Class2="Pyramidal cell")
hcCA1ApicalSpec <- list(ArborType="ApicalDendrite",ExperCond="Control",BrainRegion="Hippocampus",Class2="Pyramidal cell",Region2="CA1")
hcCA3ApicalSpec <- list(ArborType="ApicalDendrite",ExperCond="Control",BrainRegion="Hippocampus",Class2="Pyramidal cell",Region2="CA3")
specifications <- list(Cortical=ncApicalSpec,CA1=hcCA1ApicalSpec,CA3=hcCA3ApicalSpec)
classXlims <- c(0,150)

classPalette <- c("#CC9900","#6600CC","#006633")

# %C by sequence length
cFreqList <- list()
for (i in 1:length(specifications)){
  cFreqList[[i]] <- getSubset2(realCFreqs,specifications[[i]])
  cFreqList[[i]]$Group <- paste(names(specifications)[i]," (",nrow(cFreqList[[i]]),")",sep="")
  cFreqList[[i]] <- cbind(cFreqList[[i]],SeqLen=motifMetaData[rownames(cFreqList[[i]]),"SeqLen"])
  if (i == 1) plotdf <- cFreqList[[i]] else plotdf <- rbind(plotdf,cFreqList[[i]])
}

CairoWin()
ggplot(plotdf,aes(x = SeqLen, y = C, colour = Group, group=Group)) + 
  stat_smooth(method = "loess", span=.3, se = TRUE,level = 0.95, aes(fill = Group),size=1)+
  scale_colour_manual(values=classPalette)+
  scale_fill_manual(values=classPalette)+
  #coord_cartesian(xlim=xlims, ylim = c(.3, .7))+
  labs(colour="Neuron Class",fill="Neuron Class",x="Sequence Length", y="Percent C")

CairoWin()
ggplot(subset(plotdf,SeqLen<=250),aes(SeqLen,fill=Group,alpha=.05))+geom_density(linetype=0)+
  scale_fill_manual(values=classPalette)+
  coord_cartesian(xlim=xlims)+
  scale_y_continuous(breaks=c(0,.05),minor_breaks=0.023)


# Dimers & Trimers
ylimsByK[[3]] <- c(.2,.75)
angleByK <- list(0,0,90)
k <- 2
kData <- myData[[k]]
neuriteSet <- intersect(rownames(kData),rownames(plotdf))
kData <- kData[neuriteSet,]

#neuriteSet <- intersect(rownames(kData),c(rownames(interneuronCFreq),rownames(pyramidalCFreq)))
#kData <- kData[motifMetaData[neuriteSet,"SeqLen"] <= 100,]

validKmers <- removeATT("STL",colnames(kData))
kData <- cbind(kData[,validKmers],plotdf[neuriteSet,"Group",drop=F])

# Convert from wide to long
myDataLong <- reshape(kData,direction="long",varying=list(validKmers),times=validKmers,idvar="SeqName",ids=rownames(kData),timevar="Kmer",v.names="PercentileRank")

# Determine kmer averages to sort in ascending order
kmerMeans <- aggregate(myDataLong$PercentileRank,by=list(myDataLong$Kmer),FUN=mean)
kmerFactor <- factor(myDataLong$Kmer,levels=kmerMeans[order(kmerMeans[,2]),1])
myDataLong$Kmer <- kmerFactor

# Remove kmers where max means difference is less than .04
# Specific to apical dendrites
#myDataLong <- subset(myDataLong,Kmer%in%c("ACC","TCT","ACA","CCT","L-CAA","L-AAT","L-TAA","AAT","L-CAT","CAA","AAC","L-AAA","CAT","L-TAT","TCA","CCC","ACT"))
# Specific to axons (cortical pyramidal and interneuron
#myDataLong <- subset(myDataLong,Kmer%in%c("TCT","L-CAA","CAA","AAT","ACC","CTC","CCA","ATA","L-TAT","L-TAC","CAC","CCC","ACA","TCA","AAC","L-CAT","ACT","ATC","L-TAA","CTA","TCC","CAT"))

# Plot
CairoWin()
ggplot(myDataLong,aes(Kmer,PercentileRank,fill=Group))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  scale_fill_manual(values=classPalette)+
  coord_cartesian(ylim=classYlims[[k]])+
  theme(axis.text.x = element_text(angle = angleByK[[k]], hjust = 0))

ggplot(myDataLong,aes(Kmer,PercentileRank,fill=NeuronClass))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  scale_fill_manual(values=classPalette)+
  coord_cartesian(ylim=ylimsByK[[k]])+
  labs(title="Axons shorter than 100")+
  theme(axis.text.x = element_text(angle = angleByK[[k]], hjust = 0))

##### Length Effect on dimers and trimers ########
#x11(width=800,height=600)
#par(mfrow=c(3,3))
#par(mar=c(2,2,2,1), oma=c(1,1.5,1,1))
pcVsSeqLenLevels <- c("Apical","Axon","Dendrite","Interstitial Growth","Tree Shapes","Terminal Growth")

k <- 2
#kmers <- colnames(prDataB8Combo[[k]])
kmers <- c("AT","CT","AA","CC","AC")

kmerFreqs <- prDataB8Combo[[k]][,kmers]
axonKmerFreq <- getSubset2(kmerFreqs,list(ArborType="Axon",ExperCond="Control",Protocol=c("In vivo","In vitro","Not reported")),motifMetaData)
axonKmerFreq <- cbind(axonKmerFreq,SeqLen=motifMetaData[rownames(axonKmerFreq),"SeqLen"])
dendriteKmerFreq <- getSubset2(kmerFreqs,list(ArborType=c("Dendrite","BasalDendrite"),ExperCond="Control",Protocol=c("In vivo","In vitro","Not reported")),motifMetaData)
dendriteKmerFreq <- cbind(dendriteKmerFreq,SeqLen=motifMetaData[rownames(dendriteKmerFreq),"SeqLen"])
#  apicalDimerFreq <- getSubset2(dimerFreqs,list(ArborType="ApicalDendrite",ExperCond="Control"))
#  apicalDimerFreq <- cbind(apicalDimerFreq,SeqLen=motifMetaData[rownames(apicalDimerFreq),"SeqLen"])
#  apicalDimerFreq <- apicalDimerFreq[apicalDimerFreq$SeqLen < 60,]
plotdf <- rbind(axonKmerFreq,dendriteKmerFreq)
#plotdf <- rbind(plotdf,apicalDimerFreq)
arborGroup <- c(rep("Axon",nrow(axonKmerFreq)),rep("Dendrite",nrow(dendriteKmerFreq)))
#arborGroup <- c(arborGroup,rep("Apical",nrow(apicalDimerFreq)
#arborGroup <- c(rep("Axon",nrow(axonDimerFreq)),rep("Apical",nrow(apicalDimerFreq)),rep("Dendrite",nrow(dendriteDimerFreq)))
#plotdf$Group <- factor(arborGroup,levels=pcVsSeqLenLevels,ordered=T)
plotdf$Group <- arborGroup

# Add in low-order biased terminal growth and segmental growth
growthKmerFreq <- subset(extremeQSGrowthKmers,Growth=="Q0S0.4")[,c(kmers,"Length","Growth")]
growthKmerFreq <- rbind(growthKmerFreq,subset(growthDataExt,Growth=="Segmental")[,c(kmers,"Length","Growth")])
growthKmerFreq$Growth[growthKmerFreq$Growth=="Q0S0.4"] <- "Low-order Biased Terminal Growth"
colnames(growthKmerFreq)[colnames(growthKmerFreq)=="Growth"] <- "Group"
colnames(growthKmerFreq)[colnames(growthKmerFreq)=="Length"] <- "SeqLen"

for (kmer in kmers){
#for (kmer in c("CC","CT","TA","TC","TT")){

#  ymin <- min(sapply(c("Axon","Apical","Dendrite"),
  ymin <- min(sapply(c("Axon","Dendrite"),
                     function(grp,plotdf){
                       inds <- as.character(plotdf$Group)==grp
                       return(sort(plotdf[inds,1])[sum(inds)*.2])},plotdf))
#  ymax <- max(sapply(c("Axon","Apical","Dendrite"),
  ymax <- max(sapply(c("Axon","Dendrite"),
                     function(grp,plotdf){
                       inds <- as.character(plotdf$Group)==grp
                       return(sort(plotdf[inds,1])[sum(inds)*.8])},plotdf))
  ylims <- c(ymin,ymax)
#  png(paste("C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/Figures/",dataset,"KmersBySeqLen_",kmer,".png",sep=""),300,250)
  png(paste(motifDataDirectory,"/MotifAnalysis/",dataset,"KmersBySeqLen_",kmer,".png",sep=""),400,320)
  print(ggplot(subset(plotdf,SeqLen<250),aes_string(x = "SeqLen", y = kmer, colour = "Group", group="Group")) + 
    stat_smooth(method = "loess", span=.3, se = TRUE,level = 0.95, aes(fill = Group),size=1)+
    stat_smooth(data=growthKmerFreq,method = "loess", span=.3, se = F,level = 0.95, size=1)+
    scale_colour_manual(values=noApicalPal,guide=F)+
    scale_fill_manual(values=noApicalPal,guide=F)+
    #coord_cartesian(xlim=c(0,250),ylim=ylims)+
    coord_cartesian(xlim=c(0,200))+
    labs(colour="Arbor Type",fill="Arbor Type",x="Sequence Length", y=paste(kmer,"Percentile Rank"))+
    getTheme(17))
  dev.off()
}

# Target axons and dendrites of specific dimers "AT","CT","AA"
#kmers <- c("AT","CT","AA")
k <- 2
kmers <- colnames(prDataB8Combo[[k]])
kmerFreqs <- getSubset2(prDataB8Combo[[k]],list(ArborType=c("Axon","Dendrite","BasalDendrite")),motifMetaData)[,kmers,drop=F]

kmer <- "AT"
k <- nchar(kmer)
#kmerFreqs <- getSubset2(prDataB8Combo[[k]],list(ArborType=c("Axon","Dendrite","BasalDendrite")),motifMetaData)[,kmer,drop=F]
  
axonKmerFreq <- getSubset2(kmerFreqs,list(ArborType="Axon",ExperCond="Control"))
axonKmerFreq <- cbind(axonKmerFreq,SeqLen=motifMetaData[rownames(axonKmerFreq),"SeqLen"])
axonKmerFreq$Group <- "Axon"
dendriteKmerFreq <- getSubset2(kmerFreqs,list(ArborType=c("Dendrite","BasalDendrite"),ExperCond="Control"))
dendriteKmerFreq <- cbind(dendriteKmerFreq,SeqLen=motifMetaData[rownames(dendriteKmerFreq),"SeqLen"])
dendriteKmerFreq$Group <- "Dendrite"
  
# Add in growth
if (k == 2){
  #growthdf <- subset(coreGrowthData,Growth%in%c("Segmental","Terminal"))[,c(kmer,"Length","Growth")]
  growthdf <- subset(coreGrowthData,Growth%in%c("Segmental","Terminal"))[,c(kmers,"Length","Growth")]
}else if (k == 3){
  #termGrowthTrimers, varGrowthTrimers, qGrowthTrimers, narrowQSGrowthTrimers
  #growthdf <- subset(termGrowthTrimers,Growth%in%c("Segmental","Terminal"))[,c(kmer,"Length","Growth")]
  growthdf <- subset(termGrowthTrimers,Growth%in%c("Segmental","Terminal"))[,c(kmers,"Length","Growth")]
}
colnames(growthdf)[(ncol(growthdf)-1):ncol(growthdf)] <- c("SeqLen","Group")
growthdf$Group <- as.character(growthdf$Group)
#growthdf <- sample.rows(growthdf,0.5)

plotdf <- rbind(rbind(axonKmerFreq,dendriteKmerFreq),growthdf)
arborGroup <- c(axonKmerFreq$Group,dendriteKmerFreq$Group,growthdf$Group)
#plotdf$Group <- factor(arborGroup,levels=c("Axon","Dendrite","Segmental","Terminal"),ordered=T)
plotdf$Group <- factor(arborGroup,levels=c("Axon","Dendrite","Segmental","Terminal"),ordered=T)

## Include AgeClass in Group breakdown
plotdf$Group <- as.character(plotdf$Group)
# Update Group assignment with AgeClass of remaining axons and dendrites
#neuriteInds <- plotdf$Group%in%c("Axon","Dendrite")&motifMetaData[rownames(plotdf),"AgeClass"]%in%c("Young","Adult")
neuriteInds <- plotdf$Group=="Dendrite"&motifMetaData[rownames(plotdf),"AgeClass"]%in%c("Young","Adult")
plotdf[neuriteInds,"Group"] <- paste(plotdf[neuriteInds,"Group"],motifMetaData[rownames(plotdf)[neuriteInds],"AgeClass"],sep="-")
# Remove dendrites that aren't Adult or Young
groups <- c("Axon","Dendrite-Young","Dendrite-Adult","Segmental","Terminal")
plotdf <- subset(plotdf,Group%in%groups)

plotdf$Group <- factor(plotdf$Group,levels=groups,ordered=T)

plotdf <- subset(plotdf,SeqLen < 250)

#LASTTIME
#png(paste("C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/Figures/",dataset,"DimersBySeqLen_",dimer,".png",sep=""),800,650)
kmer <- "TC"
#png(paste("/home/tgillett/results/MotifAnalysis/",dataset,"KmerBySeqLen_",kmer,".png",sep=""),800,650)
png(paste("/home/tgillett/results/MotifAnalysis/",dataset,"KmerBySeqLen_",kmer,"_ByAge.png",sep=""),800,650)
print(ggplot(plotdf,aes(x = SeqLen, y = plotdf[,colnames(plotdf)==kmer], colour = Group, group=Group)) + 
        stat_smooth(method = "loess", span=.3, se = TRUE,level = 0.95, aes(fill = Group),size=1)+
#        scale_colour_manual(values=noApicalPal)+
#        scale_fill_manual(values=noApicalPal)+
        scale_colour_manual(values=withApicalPal)+
        scale_fill_manual(values=withApicalPal)+
        coord_cartesian(xlim=c(0,200),ylim=c(0,1))+
        labs(colour="Arbor Type",fill="Arbor Type",x="Sequence Length", y=paste(kmer,"Percentile Rank"))+
        getTheme(17))
dev.off()

# Split dendrites by age class for specific dimers, and/or trimers


#### Spur removal effects ####
# 5um spurs
spinesRemoved <- masterMetaData$SeqLen - motifMetaData$SeqLen
names(spinesRemoved) <- rownames(masterMetaData)
neuriteNames <- union(rownames(apicalCFreq),union(rownames(axonCFreq),rownames(dendriteCFreq)))
spinesRemoved <- spinesRemoved[neuriteNames]
hist(spinesRemoved[spinesRemoved > 5],breaks=40)
CairoWin()
hist(spinesRemoved[rownames(apicalCFreq)][spinesRemoved[rownames(apicalCFreq)] > 5],breaks=40,main="Apical Spines Removed")
hist(spinesRemoved[rownames(axonCFreq)][spinesRemoved[rownames(axonCFreq)] > 5],breaks=40,main="Axon Spines Removed")
hist(spinesRemoved[rownames(dendriteCFreq)][spinesRemoved[rownames(dendriteCFreq)] > 5],breaks=40,main="Dendrite Spines Removed")

summary(spinesRemoved[rownames(apicalCFreq)])
summary(spinesRemoved[rownames(axonCFreq)])
summary(spinesRemoved[rownames(dendriteCFreq)])
spursRemovedDF <- data.frame(SeqLen=masterMetaData[neuriteNames,"SeqLen"],SpinesRemoved=spinesRemoved,Group=masterMetaData[neuriteNames,"ArborType"],PercentRemoved=spinesRemoved/masterMetaData[neuriteNames,"SeqLen"])
spursRemovedDF[spursRemovedDF$Group=="BasalDendrite","Group"] <- "Dendrite"
plot(spursRemovedDF)
ggplot(spursRemovedDF,aes(x=SeqLen,y=PercentRemoved,colour = Group, group=Group))+
  scale_colour_manual(values=withApicalPal,guide=F)+
  scale_fill_manual(values=withApicalPal,guide=F)+
  coord_cartesian(xlim=c(0,250))+
  stat_smooth(method = "loess", span=.3, se = TRUE,level = 0.95, aes(fill = Group),size=1)

#### Growth Models: Metrics, Monomers & Dimers ####

dimers <- c("AA","AC","AT","CA","CC","CT","TA","TC","TT")
growthLong <- reshape(growthData[growthData$Length == 40,],direction="long",varying=list(dimers),idvar="SeqName",ids=rownames(growthData)[growthData$Length == 40],times=dimers,timevar="Kmer",v.names="PercentileRank")

barWidth <- 0.6
dodgeWidth <- 0.7

segAndTermDimerPlot <- ggplot(growthLong,aes(x=Kmer,y=PercentileRank,fill=Growth,group=Growth,width=barWidth))+
  stat_summary(fun.y=mean, geom="bar",colour="white",position=position_dodge(width = dodgeWidth))+
  stat_summary(fun.y=mean, fun.ymin=lowsem, fun.ymax=highsem,position=position_dodge(width = dodgeWidth), geom="linerange",color = 'black')
ggsave(paste(figDir,"DimerPRs-Segmental&TerminalGrowth-L40.png",sep=""),segAndTermDimerPlot)

# Dimers at length 40
CairoWin()
ggplot(growthLong,aes(x=Kmer,y=PercentileRank,fill=Growth))+
  geom_boxplot()+
  labs(title="Growth Model Dimers at Length 40",colour="Growth Model",x="Kmer", y="Percentile Rank")

CairoWin()
ggplot(growthData,aes(x = Length, y = AT, fill=Growth))+
  geom_boxplot()
  labs(title="Growth Model Dimers",colour="Growth Model",x="Sequence Length (Number of Bifurcations)", y="AT Percentile Rank")


# Asymmetry at SeqLen 40
ggplot(subset(growthData,Length==40),aes(x = Growth, y = Asymmetry))+
  geom_boxplot()+
  labs(title="Growth Model Asymmetry",colour="Growth Model",y="Asymmetry")
ggplot(subset(growthData,Length==40),aes(Asymmetry,fill = Growth))+
  geom_density(alpha=.4)+
  labs(title="Growth Model Asymmetry",colour="Growth Model",x="Asymmetry")

CairoWin()
ggplot(subset(growthData,Growth!="ApicalModel"),aes(x = Length, y = CA, colour=Growth, fill=Growth))+
  stat_smooth(method = "loess", span=.3, se = TRUE,level = 0.95, aes(fill = Growth),size=1)+
  labs(title="Growth Model CA by Size",colour="Growth Model",x="Sequence Length (Number of Bifurcations)", y="CA")


CairoWin()
ggplot(growthData,aes(x = Length, y = Caulescence, colour=Growth, fill=Growth))+
  stat_smooth(method = "loess", span=.3, se = TRUE,level = 0.95, aes(fill = Growth),size=1)+
  labs(title="Growth Model Caulescence by Size",fill="Growth Model",colour="Growth Model",x="Sequence Length (Number of Bifurcations)", y="Caulescence")

# Other models
CairoWin()
ggplot(otherGrowthData,aes(x = Length, y = Asymmetry, colour=Growth, fill=Growth))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  labs(title="Growth Model Asymmetry by Size",fill="Growth Model",colour="Growth Model",x="Sequence Length (Number of Bifurcations)", y="Asymmetry")

CairoWin()
ggplot(subset(growthData,Growth!="ApicalModel"),aes(x = Length, y = PercentC, fill=Growth))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  labs(title="Growth Model Percent C by Size",colour="Growth Model",x="Sequence Length (Number of Bifurcations)", y="Percent C")

CairoWin()
ggplot(growthData,aes(x = Length, y = CT, fill=Growth))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  labs(title="Growth Model CT by Size",colour="Growth Model",x="Sequence Length (Number of Bifurcations)", y="CT Percentile Rank")

CairoWin()
ggplot(growthData,aes(x = Length, y = AT, fill=Growth))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  labs(title="Growth Model AT by Size",colour="Growth Model",x="Sequence Length (Number of Bifurcations)", y="AT Percentile Rank")

CairoWin()
ggplot(growthData,aes(x = Length, y = CA, fill=Growth))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  labs(title="Growth Model CA by Size",colour="Growth Model",x="Sequence Length (Number of Bifurcations)", y="CA Percentile Rank")

CairoWin()
ggplot(growthData,aes(x = Length, y = AA, fill=Growth))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  labs(title="Growth Model AA by Size",colour="Growth Model",x="Sequence Length (Number of Bifurcations)", y="AA Percentile Rank")

CairoWin()
ggplot(growthData,aes(x = Length, y = TT, fill=Growth))+
  stat_summary(fun.y=mean, geom="bar",position="dodge",colour="white")+
  stat_summary(fun.y=mean, fun.ymin=lowsd, fun.ymax=highsd, geom="errorbar", position="dodge",color = 'black', size=.5)+
  labs(title="Growth Model TT by Size",colour="Growth Model",x="Sequence Length (Number of Bifurcations)", y="TT Percentile Rank")

# Subsets of dendrites, apical dendrites, and axons along with growth models
growthCompareSub1 <- getSubset(otherGrowthData,Length==40)
colnames(growthCompareSub1)[1] <- c("Group")

growthCompareSub2 <- getSubset2(arborTopoMetrics,list(ArborType="ApicalDendrite",Region2="CA1"),motifMetaData,maxLength=60)
growthCompareSub2$Group <- "ApicalCA1"
growthCompareSub2b <- getSubset2(arborTopoMetrics,list(ArborType="ApicalDendrite",Region2="CA3"),motifMetaData,maxLength=60)
growthCompareSub2b$Group <- "ApicalCA3"
growthCompareSub2 <- rbind(growthCompareSub2,growthCompareSub2b)
growthCompareSub2b <- getSubset2(arborTopoMetrics,list(ArborType="ApicalDendrite",BrainRegion="Neocortex"),motifMetaData,maxLength=60)
growthCompareSub2b$Group <- "ApicalNeocortex"
growthCompareSub2 <- rbind(growthCompareSub2,growthCompareSub2b)
growthCompareSub2b <- getSubset2(arborTopoMetrics,list(ArborType="Axon"),motifMetaData,maxLength=60)
growthCompareSub2b$Group <- "Axon"
growthCompareSub2 <- rbind(growthCompareSub2,growthCompareSub2b)
growthCompareSub2b <- getSubset2(arborTopoMetrics,list(ArborType="Dendrite"),motifMetaData,maxLength=60)
growthCompareSub2b$Group <- "Dendrite"
growthCompareSub2 <- rbind(growthCompareSub2,growthCompareSub2b)

growthCompareSub2 <- growthCompareSub2[,c(8,1,3,6)]
growthCompareSub2 <- cbind(growthCompareSub2,realCFreqs[rownames(growthCompareSub2),"C"])
colnames(growthCompareSub2)[c(3,5)] <- c("Asymmetry","PercentC")
growthCompareSub2 <- cbind(growthCompareSub2,prDataB8Combo_40[[2]][rownames(growthCompareSub2),])
growthCompareSub2 <- subset(growthCompareSub2,!is.na(AT))

growthCompare <- rbind(growthCompareSub1,growthCompareSub2)

CairoWin()
ggplot(growthCompare,aes(x = Group, y = Asymmetry, fill=Group))+
  geom_boxplot(notch=T)+
  labs(title="Growth Model Asymmetry",colour="Group",y="Asymmetry")
CairoWin()
ggplot(growthCompare,aes(x = Group, y = Caulescence, fill=Group))+
  geom_boxplot(notch=T)+
  labs(title="Growth Model Caulescence",colour="Group",y="Caulescence")
CairoWin()
ggplot(growthCompare,aes(x = Group, y = PercentC, fill=Group))+
  geom_boxplot(notch=T)+
  labs(title="Arbor types and growth models",colour="Group",y="Percent C")
CairoWin()
ggplot(growthCompare,aes(x = Group, y = AT, fill=Group))+
  geom_boxplot(notch=T)+
  labs(colour="Group",y="AT Percentile Ranks")

plot(growthCompare$PercentC,growthCompare$AA)

# Apical Dendrites by region and growth models
apicalSub1 <- growthLong[as.character(growthLong$Growth)%in%c("ApicalModel","ApicalModelV2"),c(6,7,8,1)]
apicalSub1 <- growthLong[,c(6,7,8,1)]
apicalSub1 <- growthLong[as.character(growthLong$Growth)%in%c("ApicalModelV2"),c(6,7,8,1)]
apicalSub1 <- growthLong[as.character(growthLong$Growth)%in%c("Terminal","Segmental","ApicalModelV2"),c(6,7,8,1)]

colnames(apicalSub1)[4] <- "ArborType"
apicalSub1$ArborType[apicalSub1$ArborType=="ApicalModelV2"] <- "ApicalModel"
apicalSub2 <- myDataLongSub[myDataLongSub$ArborType=="ApicalDendrite"&masterMetaData[myDataLongSub$SeqName,"BrainRegion"]%in%c("Hippocampus","Neocortex"),]
apicalSub2$ArborType <- masterMetaData[apicalSub2$SeqName,"BrainRegion"]
apicalData <- rbind(apicalSub1,apicalSub2)
CairoWin()
ggplot(apicalData,aes(x=Kmer,y=PercentileRank,fill=ArborType))+
  geom_boxplot()+
  labs(title="Growth Model Dimers at Length 40",colour="Growth Model",x="Kmer", y="Percentile Rank")

summary(motifMetaData[unique(apicalSub2$SeqName),"SeqLen"])
summary(subset(motifMetaData[unique(apicalSub2$SeqName),],BrainRegion=="Neocortex")$SeqLen)
summary(subset(motifMetaData[unique(apicalSub2$SeqName),],Region2=="CA3")$SeqLen)
summary(subset(motifMetaData[unique(apicalSub2$SeqName),],Region2=="CA1")$SeqLen)
# Apical Dendrites by region and growth models

#apicalSub2 <- myDataLongSub[myDataLongSub$ArborType=="ApicalDendrite"&masterMetaData[myDataLongSub$SeqName,"BrainRegion"]%in%c("Hippocampus","Neocortex")&!masterMetaData[myDataLongSub$SeqName,"Region2"]%in%c("CA2","Subiculum","Entorhinal"),]
hcInds <- masterMetaData[apicalSub2$SeqName,"Region2"] %in% c("CA1","CA3")
apicalSub2[hcInds,"ArborType"] <- masterMetaData[apicalSub2$SeqName[hcInds],"Region2"]
#ncInds <- masterMetaData[apicalSub1$SeqName,"BrainRegion"] == "Neocortex"
#apicalSub2[ncInds,"ArborType"] <- "Neocortex"
apicalSub2 <- subset(apicalSub2,ArborType!="Hippocampus")

apicalData <- rbind(apicalSub1,apicalSub2)
CairoWin()
ggplot(apicalData,aes(x=Kmer,y=PercentileRank,fill=ArborType))+
  geom_boxplot()+
  labs(title="Growth Model Dimers at Length 20",colour="Growth Model",x="Kmer", y="Percentile Rank")

# %C by length
ncApicalCFreq <- getSubset2(realCFreqs,ncApicalSpec,maxLength=80)
ncApicalCFreq <- cbind(ncApicalCFreq,SeqLen=motifMetaData[rownames(ncApicalCFreq),"SeqLen"])
hcCA1ApicalCFreq <- getSubset2(realCFreqs,hcCA1ApicalSpec,maxLength=80)
hcCA1ApicalCFreq <- cbind(hcCA1ApicalCFreq,SeqLen=motifMetaData[rownames(hcCA1ApicalCFreq),"SeqLen"])
hcCA3ApicalCFreq <- getSubset2(realCFreqs,hcCA3ApicalSpec,maxLength=80)
hcCA3ApicalCFreq <- cbind(hcCA3ApicalCFreq,SeqLen=motifMetaData[rownames(hcCA3ApicalCFreq),"SeqLen"])

plotdf <- rbind(rbind(ncApicalCFreq,hcCA1ApicalCFreq),hcCA3ApicalCFreq)
apicalGroup <- c(rep("Neocortical",nrow(ncApicalCFreq)),rep("CA1",nrow(hcCA1ApicalCFreq)),rep("CA3",nrow(hcCA3ApicalCFreq)))
pcVsSeqLenLevels <- c("Neocortical","CA1","CA3","Interstitial Growth","Tree Shapes","Terminal Growth","Apical Model 1", "Apical Model 2")
  
plotdf$Group <- factor(apicalGroup,levels=pcVsSeqLenLevels,ordered=T)

plotdf2 <- rbind(rbind(termGrowCFreqs,interstGrowCFreqs), treeShapeCFreqs)
plotdf2$Group <- c(rep("Terminal Growth",nrow(termGrowCFreqs)),rep("Interstitial Growth",nrow(interstGrowCFreqs)),rep("Tree Shapes",nrow(treeShapeCFreqs)))
plotdf2$Group <- factor(plotdf2$Group,levels=pcVsSeqLenLevels,ordered=T)
# Add in apical models
growthSub <- growthData[growthData$Growth%in%c("ApicalModel","ApicalModelV2"),c("PercentC","Length","Growth")]
growthSub$Growth <- as.character(growthSub$Growth)
growthSub[growthSub$Growth=="ApicalModel","Growth"] <- "Apical Model 1"
growthSub[growthSub$Growth=="ApicalModelV2","Growth"] <- "Apical Model 2"
growthSub$Length <- growthSub$Length + round(rnorm(nrow(growthSub),0,2))
colnames(growthSub) <- colnames(plotdf)
plotdf2 <- rbind(plotdf2,growthSub)

plotdfCombo <- rbind(plotdf,plotdf2)

plotarea <- ggplot(plotdf,aes(x = SeqLen, y = C, colour = Group, group=Group)) + 
  #geom_point() + 
  stat_smooth(method = "loess", span=.3, se = TRUE,level = 0.95, aes(fill = Group),size=1)+
  stat_smooth(data=plotdf2, method = "loess", span=.3, se = FALSE,size=0.7)+
  scale_colour_manual(values=myArborPal)+
  #scale_colour_manual(values=c(withApicalPal,myArborPal[-c(1,2,3)]))+
  scale_fill_manual(values=myArborPal[1:3])+
  #scale_fill_manual(values=withApicalPal)+
  coord_cartesian(xlim=c(0,250), ylim = c(.2, .7))+
  labs(colour="Arbor Type",fill="Arbor Type",x="Sequence Length", y="Percent C")
#xlab("Sequence Length")+ ylab("Percent C")+ 
plotarea


### DIMERS ###
dimerIndices <- nchar(colnames(axonKmerPRs))==2
dimers <- colnames(axonKmerPRs)[dimerIndices]
freqSortedDimers <- dimers[order(apply(allNeuriteKmerPRs[,dimerIndices],2,mean))]
# All Neurites
boxplot(allNeuriteKmerPRs[,freqSortedDimers],main="Normalized Dimer Frequency Distributions\nAll Neurites",xlab="Dimer",ylab="Normalized Frequency")
# By arbor type
neuriteDimerByType <- cbind(Sequence=rownames(allNeuriteKmerPRs),allNeuriteKmerPRs[,freqSortedDimers],ArborType=motifMetaData[rownames(allNeuriteKmerPRs),"ArborType"])
#neuriteDimerByTypeLong <- reshape(neuriteDimerByType,varying=freqSortedDimers,idvar="Sequence",timevar="Dimer",time=freqSortedDimers,v.names="NormalizedFrequency",direction="long")
#rownames(neuriteDimerByTypeLong) <- NULL
axonDimers <- axonKmerPRs[,freqSortedDimers]
dendDimers <- dendKmerPRs[,freqSortedDimers]
apicDimers <- apicKmerPRs[,freqSortedDimers]
#boxplot(NormalizedFrequency~Dimer+ArborType,data=neuriteDimerByTypeLong,col=c(2,3,4),main="Normalized Dimer Frequency Distributions\nAll Neurites",xlab="Dimer",ylab="Normalized Frequency")
boxplot(axonDimers,col=2,notch=T,boxwex=.19,at=(1:9),main="Normalized Dimer Frequency Distributions",xlab="Dimer",ylab="Normalized Frequency")
boxplot(dendDimers,col=3,notch=T,add=T,boxwex=.19,at=(1:9)-.28,xaxt='n')
boxplot(apicDimers,col=4,notch=T,add=T,boxwex=.19,at=(1:9)+.28,xaxt='n')
legend(6,.25,legend=c("Dendrite","Axon","ApicalDendrite"),fill=c(3,2,4),cex=.7)

# Dimer PTs as a function of sequence length
axonDimerFreq <- getSubset(allNeuriteKmerPRs,arborType="Axon")
axonDimerFreq <- cbind(axonDimerFreq,SeqLen=metaData[axonDimerFreq$Sequence,"SeqLen"])
dendriteDimerFreq <- getSubset(kmerFreqs[[2]],arborType="Dendrite")
dendriteDimerFreq <- cbind(dendriteDimerFreq,SeqLen=metaData[dendriteDimerFreq$Sequence,"SeqLen"])
apicalDimerFreq <- getSubset(kmerFreqs[[2]],arborType="ApicalDendrite")
apicalDimerFreq <- cbind(apicalDimerFreq,SeqLen=metaData[apicalDimerFreq$Sequence,"SeqLen"])

plotSmooths(axonDimerFreq,"CT",minValues=10,title="Arbor CT Frequencies",new=T,fcol="cyan2",fylim=fylim,lwd=2)
plotSmooths(apicalDimerFreq,"CT",minValues=10,new=F,fcol="brown3",lwd=2,fylim=fylim)
plotSmooths(dendriteDimerFreq,"CT",minValues=10,new=F,fcol="cornflowerblue",lwd=2,fylim=fylim)

### TRIMERS ###

# Produce box&whisker plot of kmers that don't differ substantially between arbor types
neuriteTrimers <- c("AAC","AAT","CAC","CTA","CTC","CTT","TAC","TTA","TTC","TTT","sATA","sATC","sTAT")
boxplot(allNeuriteKmerPRs[,neuriteTrimers])

# And for each arbor type to make sure distribution shapes aren't clearly different
boxplot(axonKmerPRs[,nchar(colnames(axonKmerPRs))==2])
boxplot(dendriteKmerPRs[,nchar(colnames(axonKmerPRs))==2])
boxplot(apicalDendriteKmerPRs[,nchar(colnames(axonKmerPRs))==2])

boxplot(allNeuriteKmerPRs[,neuriteTrimers],notch=F)


# Produce bar plot of kmers that differ substantialy between arbor types
arborDistinctTrimers <- c()

#### Trimer Motifs: Growth model vs arbor types ####
# Read in terminal growth trimer percentile rank data
#termGrowthTrimers <- read.csv(paste(motifDataDirectory,"/MotifAnalysis/GrowthModelTrimerPRs.csv",sep=""),stringsAsFactors=F)
#varGrowthTrimers <- read.csv(paste(motifDataDirectory,"/MotifAnalysis/GrowthModelsTrimerPRs.csv",sep=""),stringsAsFactors=F)
qGrowthTrimers <- read.csv(paste(motifDataDirectory,"/MotifAnalysis/MidQModelsTrimerPRs.csv",sep=""),stringsAsFactors=F)
narrowQSGrowthTrimers <- read.csv(paste(motifDataDirectory,"/MotifAnalysis/NarrowQSModelsTrimerPRs.csv",sep=""),stringsAsFactors=F)
targetQSGrowthTrimers <- read.csv(paste(motifDataDirectory,"/MotifAnalysis/TargetQSModelsTrimerPRs.csv",sep=""),stringsAsFactors=F)
extremeQSGrowthKmers <- read.csv(paste(motifDataDirectory,"/MotifAnalysis/ExtremeQSModelsKmerPRs.csv",sep=""),stringsAsFactors=F)
selectQSGrowthKmers <- read.csv(paste(motifDataDirectory,"/MotifAnalysis/SelectQSModelsKmerPRs.csv",sep=""),stringsAsFactors=F)
selectQSGrowthKmers <- rbind(selectQSGrowthKmers,read.csv(paste(motifDataDirectory,"/MotifAnalysis/SelectQSModelsLargeKmerPRs.csv",sep=""),stringsAsFactors=F))
#termGrowthTrimersLong <- rehsape()
growthTrimers <- termGrowthTrimers
growthTrimers <- qGrowthTrimers
growthTrimers <- narrowQSGrowthTrimers
growthTrimers <- targetQSGrowthTrimers
growthTrimers <- extremeQSGrowthKmers

kmer <- "ACT"
k <- nchar(kmer)
kmerPRs <- getSubset2(prDataB8Combo[[k]][,kmer,drop=F],axonsSpec,motifMetaData,maxLength=250)
numAxons <- nrow(kmerPRs)
kmerPRs <- rbind(kmerPRs,getSubset2(prDataB8Combo[[k]][,kmer,drop=F],dendritesSpec,motifMetaData,maxLength=250))
numDends <- nrow(kmerPRs)-numAxons
kmerPRs$Length <- motifMetaData[rownames(kmerPRs),"SeqLen"]
kmerPRs$Group <- c(rep("Axon",numAxons),rep("Dendrite",numDends))
#kmerPRs <- rbind(kmerPRs,growthTrimers[,c(kmer,"Length")])
#numTerms <- nrow(kmerPRs)-(numDends+numAxons)
#kmerPRs$Group <- c(rep("Axon",numAxons),rep("Dendrite",numDends),as.character(growthTrimers$Growth))

ageClassString <- ""
curPal <- noApicalPal

# If adding growth models to plot
termGrowthTrimers$Growth <- as.character(termGrowthTrimers$Growth)
growthKmerPRs <- subset(termGrowthTrimers,Growth=="Segmental")[,c(kmer,"Length","Growth")]
growthKmerPRs <- rbind(growthKmerPRs,subset(extremeQSGrowthKmers,Growth=="Q0S0.4")[,c(kmer,"Length","Growth")])
colnames(growthKmerPRs)[3] <- "Group"
growthKmerPRs[growthKmerPRs$Group=="Q0S0.4","Group"] <- "Low-order biased terminal growth"

# Label dendrites by Young and Adult, removing others
#Dendrites that aren't Young or Adult
dendsOther <- rownames(subset(motifMetaData[1:(numDends+numAxons),],ArborType=="Dendrite"&!AgeClass%in%c("Adult","Young")))
kmerPRs <- kmerPRs[!rownames(kmerPRs)%in%dendsOther,]
kmerPRs$Group[kmerPRs$Group=="Dendrite"] <- paste("Dendrite",motifMetaData[rownames(kmerPRs)[kmerPRs$Group=="Dendrite"],"AgeClass"],sep="-")
ageClassString <- "_AgeClass"
curPal <- dendAgePal

ymin <- min(sapply(unique(kmerPRs$Group),
                   function(grp,plotdf,kmer){
                     inds <- as.character(plotdf$Group)==grp
                     return(sort(plotdf[inds,kmer])[sum(inds)*.2])},kmerPRs,kmer))
ymax <- max(sapply(unique(kmerPRs$Group),
                   function(grp,plotdf,kmer){
                     inds <- as.character(plotdf$Group)==grp
                     return(sort(plotdf[inds,kmer])[sum(inds)*.8])},kmerPRs,kmer))
ylims <- c(ymin,ymax)
#png(paste("C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/Figures/",dataset,"GrowthArborCompete_TrimersBySeqLen_",kmer,ageClassString".png",sep=""),400,350)
png(paste("/home/tgillett/results/MotifAnalysis/GrowthModelsArborCompete_TrimersBySeqLen_",kmer,ageClassString,".png",sep=""),600,550)
png(paste("/home/tgillett/results/MotifAnalysis/GrowthModelsArborBasic_TrimersBySeqLen_",kmer,ageClassString,".png",sep=""),600,550)
png(paste("/home/tgillett/results/MotifAnalysis/MidQGrowthModelsArborCompete_TrimersBySeqLen_",kmer,ageClassString,".png",sep=""),600,550)
png(paste("/home/tgillett/results/MotifAnalysis/NarrowQSGrowthModelsArborCompete_TrimersBySeqLen_",kmer,ageClassString,".png",sep=""),600,550)
png(paste("/home/tgillett/results/MotifAnalysis/TargetQSGrowthModelsArborCompete_TrimersBySeqLen_",kmer,ageClassString,".png",sep=""),600,550)
png(paste("/home/tgillett/results/MotifAnalysis/CurrentQSGrowthModelsArborCompete_TrimersBySeqLen_",kmer,ageClassString,".png",sep=""),600,550)
print(ggplot(kmerPRs,aes_string(x = "Length", y = kmer, colour = "Group", group="Group")) + 
        stat_smooth(method = "loess", span=.35, se = TRUE,level = 0.95, aes(fill = Group),size=1)+
        stat_smooth(data=growthKmerPRs,method = "loess", span=.35, se = F,level = 0.95,aes(group = Group), size=1)+
        #scale_colour_manual(values=noApicalPal,guide=T)+
        #scale_fill_manual(values=noApicalPal,guide=T)+
        scale_colour_manual(values=curPal[-2])+
        scale_fill_manual(values=curPal[-2])+
        coord_cartesian(xlim=c(0,160),ylim=ylims)+
        labs(colour="Tree Type",fill="Tree Type",x="Sequence Length", y=paste(kmer,"Percentile Rank"))+
        getTheme(17))
dev.off()


# Split axons by neuron type
kmerPRs2 <- kmerPRs
interneuronAxons <- intersect(rownames(kmerPRs),rownames(subset(motifMetaData,ArborType=="Axon"&Class1=="Interneuron")))
kmerPRs2[interneuronAxons,"Group"] <- paste("Axon",motifMetaData[interneuronAxons,"Class1"],sep="-")
otherChosenAxons <- intersect(rownames(kmerPRs),rownames(subset(motifMetaData,ArborType=="Axon"&Class2%in%c("Pyramidal cell","Uniglomerular projection neuron"))))
kmerPRs2[otherChosenAxons,"Group"] <- paste("Axon",motifMetaData[otherChosenAxons,"Class2"],sep="-")
otherAxons <- rownames(motifMetaData)[motifMetaData$ArborType=="Axon"&!rownames(motifMetaData)%in%union(otherChosenAxons,interneuronAxons)]
kmerPRs2 <- kmerPRs2[!rownames(kmerPRs2)%in%otherAxons,]
kmerPRs2$Group[kmerPRs2$Group=="Axon-Uniglomerular projection neuron"] <- "Axon-UPN"
kmerPRs2$Group[kmerPRs2$Group=="Axon-Pyramidal cell"] <- "Axon-Pyramidal"
inGroups <- c("Axon-Pyramidal","Axon-Interneuron","Axon-UPN","Dendrite-Young","Dendrite-Adult")

png(paste("/home/tgillett/results/MotifAnalysis/TargetQSGrowthModelsArborCompete2_TrimersBySeqLen_",kmer,"_AxonTypes",".png",sep=""),600,550)
print(ggplot(subset(kmerPRs2,Group%in%inGroups),aes(x = Length, y = CT, colour = Group, group=Group)) + 
        stat_smooth(method = "loess", span=.25, se = TRUE,level = 0.95, aes(fill = Group),size=1)+
        #scale_colour_manual(values=noApicalPal,guide=T)+
        #scale_fill_manual(values=noApicalPal,guide=T)+
        coord_cartesian(xlim=c(0,160),ylim=ylims)+
        labs(colour="Tree Type",fill="Tree Type",x="Sequence Length", y=paste(kmer,"Percentile Rank"))+
#        stat_smooth(
#          data=subset(kmerPRs,!Group%in%inGroups),
#          method = "loess", span=.3, se = F, size=1)+
        getTheme(17))
dev.off()


# Look at %C of growth methods
cDF <- getSubset2(realCFreqs,dendritesSpec,motifMetaData)
numDends <- nrow(cDF)
cDF <- rbind(cDF,getSubset2(realCFreqs,axonsSpec,motifMetaData))
numAxons <- nrow(cDF)-numDends
cDF$Length <- motifMetaData[rownames(cDF),"SeqLen"]
colnames(cDF)[1] <- "PercentC"
cDF <- rbind(cDF,growthTrimers[,c("PercentC","Length")])
numTerms <- nrow(cDF)-(numDends+numAxons)
cDF$Group <- c(rep("Dendrite",numDends),rep("Axon",numAxons),as.character(growthTrimers$Growth))

# Label dendrites by Young and Adult, removing others
#Dendrites that aren't Young or Adult
dendsOther <- rownames(subset(motifMetaData[rownames(cDF),],ArborType=="Dendrite"&!AgeClass%in%c("Adult","Young")))
cDF <- cDF[!rownames(cDF)%in%dendsOther,]
cDF$Group[cDF$Group=="Dendrite"] <- paste("Dendrite",motifMetaData[rownames(cDF)[cDF$Group=="Dendrite"],"AgeClass"],sep="-")

#png(paste("/home/tgillett/results/MotifAnalysis/GrowthModelsArborCompete_CBySeqLen.png",sep=""),600,550)
png(paste("/home/tgillett/results/MotifAnalysis/GrowthModelsArborCompete_CBySeqLen_AgeClass.png",sep=""),600,550)
#png(paste("/home/tgillett/results/MotifAnalysis/MidQGrowthModelsArborCompete_CBySeqLen.png",sep=""),600,550)
#png(paste("/home/tgillett/results/MotifAnalysis/NarrowQSGrowthModelsArborCompete_CBySeqLen.png",sep=""),600,550)
png(paste("/home/tgillett/results/MotifAnalysis/TargetQSGrowthModelsArborCompete_CBySeqLen_AgeClass.png",sep=""),600,550)
print(ggplot(subset(cDF,Length<250),aes(x = Length, y = PercentC, colour = Group, group=Group)) + 
        stat_smooth(method = "loess", span=.25, se = TRUE,level = 0.95, aes(fill = Group),size=1)+
        #scale_colour_manual(values=noApicalPal,guide=T)+
        #scale_fill_manual(values=noApicalPal,guide=T)+
        coord_cartesian(xlim=c(0,200),ylim=ylims)+
        labs(colour="Tree Type",fill="Tree Type",x="Sequence Length", y=paste("Percentile C"))+
        getTheme(17))
dev.off()

##### %C vs dimer and trimers of uniformly random trees ########

unifNmersBySizeC <- read.csv("C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/UniformlyDistRandomSeqsBySizeAndC.csv")

with(subset(unifNmersBySizeC,C/Bifurcations>.1&C/Bifurcations<=.2),plot(Bifurcations+runif(length(Bifurcations),-1,1),TA+runif(length(Bifurcations),-.01,.01),xlim=range(unifNmersBySizeC$Bifurcations),ylim=range(unifNmersBySizeC$TCT)))
with(subset(unifNmersBySizeC,C/Bifurcations>.2&C/Bifurcations<=.3),points(Bifurcations+runif(length(Bifurcations),-1,1),TA+runif(length(Bifurcations),-.01,.01),col=2))
with(subset(unifNmersBySizeC,C/Bifurcations>.3&C/Bifurcations<=.4),points(Bifurcations+runif(length(Bifurcations),-1,1),TA+runif(length(Bifurcations),-.01,.01),col=3))
with(subset(unifNmersBySizeC,C/Bifurcations>.4&C/Bifurcations<=.5),points(Bifurcations+runif(length(Bifurcations),-1,1),TA+runif(length(Bifurcations),-.01,.01),col=4))
with(subset(unifNmersBySizeC,C/Bifurcations>.5&C/Bifurcations<=.6),points(Bifurcations+runif(length(Bifurcations),-1,1),TA+runif(length(Bifurcations),-.01,.01),col=5))
with(subset(unifNmersBySizeC,C/Bifurcations>.6&C/Bifurcations<=.7),points(Bifurcations+runif(length(Bifurcations),-1,1),TA+runif(length(Bifurcations),-.01,.01),col=9))

with(subset(unifNmersBySizeC,C/Bifurcations>.1&C/Bifurcations<=.2),plot(Bifurcations+runif(length(Bifurcations),-1,1),TCT+runif(length(Bifurcations),-.01,.01),xlim=range(unifNmersBySizeC$Bifurcations),ylim=range(unifNmersBySizeC$TCT)))
with(subset(unifNmersBySizeC,C/Bifurcations>.2&C/Bifurcations<=.3),points(Bifurcations+runif(length(Bifurcations),-1,1),TCT+runif(length(Bifurcations),-.01,.01),col=2))
with(subset(unifNmersBySizeC,C/Bifurcations>.3&C/Bifurcations<=.4),points(Bifurcations+runif(length(Bifurcations),-1,1),TCT+runif(length(Bifurcations),-.01,.01),col=3))
with(subset(unifNmersBySizeC,C/Bifurcations>.4&C/Bifurcations<=.5),points(Bifurcations+runif(length(Bifurcations),-1,1),TCT+runif(length(Bifurcations),-.01,.01),col=4))
with(subset(unifNmersBySizeC,C/Bifurcations>.5&C/Bifurcations<=.6),points(Bifurcations+runif(length(Bifurcations),-1,1),TCT+runif(length(Bifurcations),-.01,.01),col=5))
with(subset(unifNmersBySizeC,C/Bifurcations>.6&C/Bifurcations<=.7),points(Bifurcations+runif(length(Bifurcations),-1,1),TCT+runif(length(Bifurcations),-.01,.01),col=9))

with(subset(unifNmersBySizeC,C/Bifurcations>.1&C/Bifurcations<=.2),plot(Bifurcations+runif(length(Bifurcations),-1,1),sAAT+runif(length(Bifurcations),-.01,.01),xlim=range(unifNmersBySizeC$Bifurcations),ylim=range(unifNmersBySizeC$TCT)))
with(subset(unifNmersBySizeC,C/Bifurcations>.2&C/Bifurcations<=.3),points(Bifurcations+runif(length(Bifurcations),-1,1),sAAT+runif(length(Bifurcations),-.01,.01),col=2))
with(subset(unifNmersBySizeC,C/Bifurcations>.3&C/Bifurcations<=.4),points(Bifurcations+runif(length(Bifurcations),-1,1),sAAT+runif(length(Bifurcations),-.01,.01),col=3))
with(subset(unifNmersBySizeC,C/Bifurcations>.4&C/Bifurcations<=.5),points(Bifurcations+runif(length(Bifurcations),-1,1),sAAT+runif(length(Bifurcations),-.01,.01),col=4))
with(subset(unifNmersBySizeC,C/Bifurcations>.5&C/Bifurcations<=.6),points(Bifurcations+runif(length(Bifurcations),-1,1),sAAT+runif(length(Bifurcations),-.01,.01),col=5))
with(subset(unifNmersBySizeC,C/Bifurcations>.6&C/Bifurcations<=.7),points(Bifurcations+runif(length(Bifurcations),-1,1),sAAT+runif(length(Bifurcations),-.01,.01),col=9))



##### Break-down by subtype #####
##IN PROGRESS##

sharedSeqs <- intersect(rownames(motifMetaData),rownames(prDataB8_40Combo))
presentMetaData <- motifMetaData[sharedSeqs,]

# Axons
axonPRs <- getSubset2(prDataB8_40Combo,specifications=list(ArborType="Axon"),minLength=25,typeMetaData=presentMetaData)

# Dendrites
dendritePRs <- getSubset2(prDataB8_40Combo,specifications=list(ArborType=c("Dendrite","BasalDendrite")),minLength=25,typeMetaData=presentMetaData)

# Apical Dendrites
apicalPRs <- getSubset2(prDataB8_40Combo,specifications=list(ArborType="ApicalDendrite"),minLength=25,typeMetaData=presentMetaData)

# Pyramidal axons
pyrCortAxonC <- getSubset2(prDataB8_40Combo,specifications=list(ArborType="Axon",Class2="Pyramidal cell",BrainRegion="Cerebral cortex"))
pyrHipAxonC <- getSubset2(prDataB8_40Combo,specifications=list(ArborType="Axon",Class2="Pyramidal cell",BrainRegion="Hippocampus"))
distributionComparison(list(Cortical=pyrCortAxonC,HC=pyrHipAxonC),las=3,title="Cortical vs Hippocampal Pyramidal Axons",error="SEM")

# Sets based on specific subgroups (SpecificationLists)
CairoWin()
ind <- 1
startInd <- 1
indCol <- c()
for (ind in startInd:length(PairwiseSpecificationLists)){
  specifications <- PairwiseSpecificationLists[[ind]]
  classPRs1 <- getSubset2(prDataB8_40Combo,specifications=specifications[[1]],typeMetaData=presentMetaData)
  classPRs2 <- getSubset2(prDataB8_40Combo,specifications=specifications[[2]],typeMetaData=presentMetaData)
  # Plot monomer, dimer, and trimer PRs
  #boxplot(randB38_4merFreqDiff,las=3,main=title,ylim=c(-.02,.02))
  #barplot(apply(randB38_4merFreqDiff[,biggestMeans],2,mean),las=3)
  
  classPRs <- list(classPRs1,classPRs2)
  #  print(paste(ind,names(PairwiseSpecificationLists)[ind]))
  tmpSigDF <- testSignificance(classPRs1,classPRs2,test=wilcox.test,display=F)
  if (ind == startInd){
    sigDF <- tmpSigDF
  }else{
    sigDF <- rbind(sigDF,tmpSigDF)
  }
  indCol <- append(indCol,rep(ind,nrow(tmpSigDF)))
  #  if (readline() == "q"){
  #    break
  #  }
}
sigDF <- cbind(Index=indCol,sigDF)

groupMeans <- distributionComparison(classPRs,las=3,title=names(PairwiseSpecificationLists)[ind],error="SEM",plotType="bar",markSignificance=T)
#distributionComparison(list(randB38_4merFreqDiff),las=3,title=title,error="SEM",ylim=c(-.005,.005))
#distributionComparison(list(randB38_4merFreqDiff[,biggestMeans]),las=3,title=title,error="SEM",ylim=c(-.005,.005))

# Look at distributions of a given kmer or pair of kmers
ind <- 3
kmer1 <- "C"
kmer2 <- ""
specifications <- PairwiseSpecificationLists[[ind]]
classPRs1 <- getSubset2(prDataB8_40Combo,specifications=specifications[[1]],typeMetaData=presentMetaData)
classPRs2 <- getSubset2(prDataB8_40Combo,specifications=specifications[[2]],typeMetaData=presentMetaData)
testSignificance(classPRs1,classPRs2)
CairoWin()
boxplot(classPRs1[,kmer1],width=1)
boxplot(classPRs2[,kmer1],width=.5,add=T,at=1.1,border=2)
plot(presentMetaData[rownames(classPRs1),"SeqLen"],classPRs1[,kmer1],cex=.5,pch=21,bg=1)
points(presentMetaData[rownames(classPRs2),"SeqLen"],classPRs2[,kmer1],cex=.5,pch=21,bg=2,col=2)
summary(lm(C~presentMetaData[rownames(classPRs1),"SeqLen"],classPRs1))
summary(lm(C~presentMetaData[rownames(classPRs2),"SeqLen"],classPRs2))

class1And2 <- rbind(classPRs1,classPRs2)
metaDataSet <- presentMetaData[rownames(class1And2),]
summary(lm(class1And2$TCT~ Archive + SeqLen + AgeClass + Species + Archive,metaDataSet))
summary(lm(class1And2$TCT~ Archive + AgeClass + Species + Archive,metaDataSet))

summary(lm(class1And2$sAAA ~ Archive + SeqLen + AgeClass + Species + Archive,metaDataSet))
summary(lm(class1And2$sAAA ~ Archive + AgeClass + Species + Archive,metaDataSet))

#specifications[[1]] <- append(specifications[[1]],list(Archive="Yuste"))
newSpecs <- list(Yuste=append(specifications[[1]],list(Archive="Yuste")),NotYuste=append(specifications[[1]],list(Archive=c("Markram","Svoboda","Staiger"))))
classPRs1 <- getSubset2(prDataB8_40Combo,specifications=newSpecs[[1]],typeMetaData=presentMetaData)
classPRs2 <- getSubset2(prDataB8_40Combo,specifications=newSpecs[[2]],typeMetaData=presentMetaData)
testSignificance(classPRs1,classPRs2)

testSignificance <- function(classPRs1,classPRs2,test=wilcox.test,display=T){
  #print(paste("N1: ",nrow(classPRs1),"; N2: ",nrow(classPRs2),sep=""))
  for (i in 1:ncol(classPRs1)){
    testResult <- test(classPRs1[,i],classPRs2[,i])
    #adjPVal <- ncol(classPRs1)*testResult$p.value
    adjPVal <- 1-(1-testResult$p.value)^ncol(classPRs1)
    meanDiff <- mean(classPRs1[,i])-mean(classPRs2[,i])
    normDist <- meanDiff/mean(c(sd(classPRs1[,i]),sd(classPRs2[,i])))
    if (adjPVal < 0.05 && display){
      print(paste(colnames(classPRs1)[i],format(meanDiff,digits=3),format(normDist,digits=3),format(testResult$p.value,digits=3),format(adjPVal,digits=3),sep="  "))
    }
    tmpDF <- data.frame(Kmer=colnames(classPRs1)[i],N1=nrow(classPRs1),N2=nrow(classPRs2),MeanDiff=meanDiff,NormDist=normDist,pval=testResult$p.value,adjPVal=adjPVal)
    if (i == 1){
      sigDF <- tmpDF
    }else{
      sigDF <- rbind(sigDF,tmpDF)
    }
  }
  return(sigDF)
}

# Uniglomerular axons

### Cortical vs Hippocampal apical dendrites
# Dimers by sequence length
dimer <- "CC" # CC, AC, CT, TT are the dimers along which cortical and hippocampal apical dendrites differ
dimerFreqs <- myData[[2]][,dimer,drop=F]

ncApicalSpec <- list(ArborType="ApicalDendrite",ExperCond="Control",BrainRegion="Neocortex",Class2="Pyramidal cell")
hcApicalSpec <- list(ArborType="ApicalDendrite",ExperCond="Control",BrainRegion="Hippocampus",Class2="Pyramidal cell")
hcCA1ApicalSpec <- list(ArborType="ApicalDendrite",ExperCond="Control",BrainRegion="Hippocampus",Class2="Pyramidal cell",Region2="CA1")
hcCA3ApicalSpec <- list(ArborType="ApicalDendrite",ExperCond="Control",BrainRegion="Hippocampus",Class2="Pyramidal cell",Region2="CA3")
specifications <- list(Cortical=ncApicalSpec,CA1=hcCA1ApicalSpec,CA3=hcCA3ApicalSpec)

ncApicalDimerFreq <- getSubset2(dimerFreqs,ncApicalSpec)
ncApicalDimerFreq <- cbind(ncApicalDimerFreq,SeqLen=motifMetaData[rownames(ncApicalDimerFreq),"SeqLen"])
hcApicalDimerFreq <- getSubset2(dimerFreqs,hcApicalSpec)
hcApicalDimerFreq <- cbind(hcApicalDimerFreq,SeqLen=motifMetaData[rownames(hcApicalDimerFreq),"SeqLen"])
hcCA1ApicalDimerFreq <- getSubset2(dimerFreqs,hcCA1ApicalSpec)
hcCA1ApicalDimerFreq <- cbind(hcCA1ApicalDimerFreq,SeqLen=motifMetaData[rownames(hcCA1ApicalDimerFreq),"SeqLen"])
hcCA3ApicalDimerFreq <- getSubset2(dimerFreqs,hcCA3ApicalSpec)
hcCA3ApicalDimerFreq <- cbind(hcCA3ApicalDimerFreq,SeqLen=motifMetaData[rownames(hcCA3ApicalDimerFreq),"SeqLen"])

plotdf <- rbind(rbind(ncApicalDimerFreq,hcCA1ApicalDimerFreq),hcCA3ApicalDimerFreq)
apicalGroup <- c(rep("Neocortical",nrow(ncApicalDimerFreq)),rep("Hippocampus CA1",nrow(hcCA1ApicalDimerFreq)),rep("Hippocampus CA3",nrow(hcCA3ApicalDimerFreq)))
plotdf$Group <- factor(apicalGroup,levels=c("Neocortical","Hippocampus CA1","Hippocampus CA3"),ordered=T)

#ylims <- sort(plotdf[,1])[nrow(plotdf)*c(.2,.8)]
ymin <- min(sapply(c("Neocortical","Hippocampus CA1","Hippocampus CA3"),
                   function(grp,plotdf){
                     inds <- as.character(plotdf$Group)==grp
                     return(sort(plotdf[inds,1])[sum(inds)*.2])},plotdf))
ymax <- max(sapply(c("Neocortical","Hippocampus CA1","Hippocampus CA3"),
                   function(grp,plotdf){
                     inds <- as.character(plotdf$Group)==grp
                     return(sort(plotdf[inds,1])[sum(inds)*.8])},plotdf))
ylims <- c(ymin,ymax)
png(paste("C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/Figures/",dataset,"ApicalDimersBySeqLen_",dimer,".png",sep=""),400,300)
print(ggplot(plotdf,aes(x = SeqLen, y = plotdf[,1], colour = Group, group=Group)) + 
        stat_smooth(method = "loess", span=.3, se = TRUE,level = 0.95, aes(fill = Group),size=1)+
        scale_colour_manual(values=withApicalPal,guide=F)+
        scale_fill_manual(values=withApicalPal,guide=F)+
        coord_cartesian(xlim=c(0,120),ylim=ylims)+
        labs(colour="Brain Region",fill="Brain Region",x="Sequence Length", y=paste(dimer,"Percentile Rank")))
dev.off()
        
# Use group differences as basis for linear models to get metadata effects on given kmers
specListName <- "ApicalDendrite/Rodent/Pyramidal cell by BrainRegion"
specifications <- SpecificationLists[[specListName]]
groupPRList <- list()
for (specInd in 1:length(specifications)){
  groupPRList[[specInd]] <- getSubset2(prDataB8_40Combo,specifications=specifications[[specInd]],typeMetaData=presentMetaData)
  if (specInd == 1){
    groupPRs <- groupPRList[[specInd]]
  }else{
    groupPRs <- rbind(groupPRs,groupPRList[[specInd]])
  }
}
metaDataSet <- presentMetaData[rownames(groupPRs),]
summary(lm(groupPRs$sAAA ~ AgeClass + Species + BrainRegion + Archive,metaDataSet))
#summary(lm(groupPRs$sAAA ~ AgeClass * Species + BrainRegion,metaDataSet))
summary(lm(groupPRs$sAAA ~ AgeClass + Species + BrainRegion + SeqLen,metaDataSet))
summary(lm(groupPRs$sAAA ~ AgeClass + Species,metaDataSet))

summary(lm(groupPRs$C ~ AgeClass + Species + BrainRegion + SeqLen,metaDataSet))
summary(lm(groupPRs$C ~ AgeClass + Species + BrainRegion : SeqLen,metaDataSet))
summary(lm(groupPRs$C ~ BrainRegion * SeqLen,metaDataSet))
subsetNames <- rownames(subset(metaDataSet,BrainRegion=="Hippocampus"))
plot(metaDataSet[subsetNames,"SeqLen"],groupPRs[subsetNames,"C"])
points(metaDataSet[subsetNames,"SeqLen"],0.688-0.133+0.0022*metaDataSet[subsetNames,"SeqLen"],col=1,pch=22,cex=.5,bg=1)
points(metaDataSet[subsetNames,"SeqLen"],0.688+0.0032*metaDataSet[subsetNames,"SeqLen"],col=1,pch=24,cex=.5,bg=1)
subsetNames <- rownames(subset(metaDataSet,BrainRegion=="Anterior olfactory nucleus"))
points(metaDataSet[subsetNames,"SeqLen"],groupPRs[subsetNames,"C"],col=2)
points(metaDataSet[subsetNames,"SeqLen"],0.688+0.0022*metaDataSet[subsetNames,"SeqLen"],col=2,pch=22,cex=.5,bg=2)
points(metaDataSet[subsetNames,"SeqLen"],0.688+0.0171*metaDataSet[subsetNames,"SeqLen"],col=2,pch=24,cex=.5,bg=2)
subsetNames <- rownames(subset(metaDataSet,BrainRegion=="Neocortex"))
points(metaDataSet[subsetNames,"SeqLen"],groupPRs[subsetNames,"C"],col=3)
points(metaDataSet[subsetNames,"SeqLen"],0.688-0.196+0.0022*metaDataSet[subsetNames,"SeqLen"],col=3,pch=22,cex=.5,bg=3)
points(metaDataSet[subsetNames,"SeqLen"],0.688+0.0019*metaDataSet[subsetNames,"SeqLen"],col=3,pch=24,cex=.5,bg=3)

transC <- qnorm(groupPRs$C)
summary(lm(transC ~ AgeClass + Species + BrainRegion : SeqLen,metaDataSet))
summary(lm(transC ~ BrainRegion * SeqLen,metaDataSet))

########## Get individual neurons that are representative of their class based on Motif PRs ###########

specification <- list(ArborType="Axon")
motifMetaData <- motifMetaData

# Get means and SD for types
PRSubset <- getSubset2(prDataB8_40Combo,specification,motifMetaData,minLength=25)
PRSubsetZ <- scale(PRSubset)
subsetMeans <- apply(PRSubset,2,mean)
subsetMeds <- apply(PRSubset,2,median)
subsetSDs <- apply(PRSubset,2,sd)
CairoWin()
boxplot(PRSubset,las=3)

# Rank all neurites based on how close to the means they are (sum squared error)
neuriteScores <- apply(PRSubset,1,neuriteRepresentativeScore,subsetMeans,subsetSDs)
sort(neuriteScores)[1:20]
areRepresentativeNeurites <- apply(PRSubset,1,isNeuriteRepresentative,subsetMeds,subsetSDs,scoreThreshold=1)
sum(areRepresentativeNeurites)
representativeNeurites <- rownames(PRSubset)[areRepresentativeNeurites]
neuriteScores[representativeNeurites]
motifMetaData[representativeNeurites,"SeqLen"]

neuriteName <- representativeNeurites[1]

# Boxplot comparison of given neurite to class
boxplot(PRSubset,las=3)
displayHowRepresentative(PRSubset,neuriteName,1,type="binary")
displayHowRepresentative(PRSubset,representativeNeurites[4],2)
#repColors <- (abs(PRSubsetZ[neuriteName,])<zScoreThreshold)+2
displayHowRepresentative <- function(PRSubset,neuriteName,num,scoreType="percentile",scoreThreshold=.2,type=c("binary","range")){
  type <- match.arg(type)
  if (type == "binary"){
    repColors <- isNeuriteKmerRepresentative(PRSubset[neuriteName,],PRSubset,scoreType=scoreType,scoreThreshold=scoreThreshold)+2
  }else{
    howRep <- howNeuriteKmerRepresentative(PRSubset[neuriteName,],PRSubset,scoreType=scoreType,scoreThreshold=scoreThreshold)
    #howRep <- sapply(howRep,min,.5)
    maxRepVal <- .25
    midRepVal <- maxRepVal/2
    #repColors <- rgb(howRep+.5,.5-howRep,0)
    red <- sapply(howRep/midRepVal,min,1)
    green <- sapply(sapply((2*midRepVal-howRep)/midRepVal,min,1),max,0)
    repColors <- rgb(red,green,0)
  }
  points(1:ncol(PRSubset),PRSubset[neuriteName,],col=1,pch=20+num,bg=repColors,cex=1.2)
}

# Barplot comparison of given neurite to class
barMat <- matrix(c(as.numeric(PRSubset[neuriteName,]),subsetMeans),2,length(subsetMeans))
colnames(barMat) <- names(subsetMeans)
barplot(barMat,beside=T,las=3)

# Compares a neurite's kmers to a mean
neuriteRepresentativeScore <- function(neuriteKmerPRs,classKmerPRs,classKmerSDs){
  scores <- (neuriteKmerPRs-classKmerPRs)/classKmerSDs
  score <- sqrt(scores%*%scores)
  return(score)
}

isNeuriteRepresentative <- function(neuriteKmerPRs,classKmerPRs,scoreType=c("zScore","percentile"),scoreThreshold=.5,proportionWithinThreshold=.95){
  scoreType <- match.arg(scoreType)
  maxNumPastThreshold <- floor((1-proportionWithinThreshold)*length(neuriteKmerPRs))
  if (scoreType == "zScore"){
    relativeDists <- (neuriteKmerPRs-apply(classKmerPRs,2,mean))/apply(classKmerPRs,2,sd)
  }else{
    percentileRanks <- apply(rbind(neuriteKmerPRs,classKmerPRs),2,function(xDist){return(percentileRank(xDist[1],xDist[-1]))})
    relativeDists <- abs(percentileRanks-.5)
  }
  return(sum(relativeDists > scoreThreshold) <= maxNumPastThreshold)
}

isNeuriteKmerRepresentative <- function(neuriteKmerPRs,classKmerPRs,scoreType=c("zScore","percentile"),scoreThreshold=.5){
  scoreType <- match.arg(scoreType)
  maxNumPastThreshold <- floor((1-proportionWithinThreshold)*length(neuriteKmerPRs))
  if (scoreType == "zScore"){
    relativeDists <- (neuriteKmerPRs-apply(classKmerPRs,2,mean))/apply(classKmerPRs,2,sd)
  }else{
    percentileRanks <- apply(rbind(neuriteKmerPRs,classKmerPRs),2,function(xDist){return(percentileRank(xDist[1],xDist[-1]))})
    relativeDists <- abs(percentileRanks-.5)
  }
  return(relativeDists <= scoreThreshold)
}

howNeuriteKmerRepresentative <- function(neuriteKmerPRs,classKmerPRs,scoreType=c("zScore","percentile"),scoreThreshold=.5){
  scoreType <- match.arg(scoreType)
  maxNumPastThreshold <- floor((1-proportionWithinThreshold)*length(neuriteKmerPRs))
  if (scoreType == "zScore"){
    relativeDists <- (neuriteKmerPRs-apply(classKmerPRs,2,mean))/apply(classKmerPRs,2,sd)
  }else{
    percentileRanks <- apply(rbind(neuriteKmerPRs,classKmerPRs),2,function(xDist){return(percentileRank(xDist[1],xDist[-1]))})
    relativeDists <- abs(percentileRanks-.5)
  }
  return(relativeDists)
}

zScore <- function(value,mean,sd){
  return((value-mean)/sd)
}

